﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LN_01
{
    class Boj
    {
        public string cil1, cil2, cil;
        public string rasaA, lovisteA, lovisteCil;
        public int i, j, z, ut;

        public string vysledek,stavA;



        //vyber cile dle zname rasy - pujde predelat az bude Pamet.cs
        public Boj(string aktivni, string rasaR, string rasaG, string rasaB, string rasaY)
        {
            string[] hraci = { "cervenka", "zelenka", "modrak", "zlutka" };
            string[] rasy = { rasaR, rasaG, rasaB, rasaY };
            cil1 = "";

            while (rasaA == null)
            {

                if (hraci[i] == aktivni)
                    rasaA = rasy[i];
                else
                    i++;
            }

            for (int j = 0; j < 4; j++)
            {
                if (rasaA != rasy[j])
                {
                    if (cil1 == "")
                        cil1 = hraci[j];
                    else
                        cil2 = hraci[j];
                }
                    
            }
        }

        //zjisteni ktery z cilu je zranenejsi a brat ho jako primarni cil
        public Boj (string cil1, string cil2, int zranR, int zranG, int zranB, int zranY)
        {
            i = 0;
            j = 0;

            if ((cil1 == "cervenka") | (cil2 == "cervenka"))
                if (i == 0)
                    i = zranR;
                else
                    j = zranR;

            if ((cil1 == "zelenka") | (cil2 == "zelenka"))
                if (i == 0)
                    i = zranG;
                else
                    j = zranG;

            if ((cil1 == "modrak") | (cil2 == "modrak"))
                if (i == 0)
                    i = zranB;
                else
                    j = zranB;

            if ((cil1 == "zlutka") | (cil2 == "zlutka"))
                if (i == 0)
                    i = zranY;
                else
                    j = zranY;

            if (i >= j)
                cil = cil1;
            else
                cil = cil2;
        }

        public Boj(string terc, string figurka, string lovisteR, string lovisteG, string lovisteB, string lovisteY, string pistole)
        {
            if (figurka == "cervenka")
                lovisteA = lovisteR;
            if (figurka == "zelenka")
                lovisteA = lovisteG;
            if (figurka == "modrak")
                lovisteA = lovisteB;
            if (figurka == "zlutka")
                lovisteA = lovisteY;

            if (terc == "cervenka")
                lovisteCil = lovisteR;
            if (terc == "zelenka")
                lovisteCil = lovisteG;
            if (terc == "modrak")
                lovisteCil = lovisteB;
            if (terc == "zlutka")
                lovisteCil = lovisteY;

            if(figurka == pistole)
            {
                if (lovisteA != lovisteCil)
                    cil = terc;
            }
            else
            {
                if (lovisteA == lovisteCil)
                    cil = terc;
            }

            

        }

        //vyhodnoceni boje
        public Boj (string aktivni, string sestka, string ctyrka, int utR, int utG, int utB, int utY)
        {
            i = Convert.ToInt32(sestka);
            j = Convert.ToInt32(ctyrka);
            // -3 nejde ve hre ziskat. Minimalni hodnota dosazitelna kartami hry je -1
            ut = -3;

            z = i - j;

            /*
           //reseni boje dle pravidel LN, zajistuje castejsi uspesny utok
           if (x >= y)
           {
               z = x - y;
           }
           else if (y > x)
           {
               z = y - x;
           }
           */
            i = 0;
            string[] hraci = { "cervenka", "zelenka", "modrak", "zlutka" };
            int[] utocneC = { utR, utG, utB, utY };

            while (ut == -3)
            {

                if (hraci[i] == aktivni)
                    ut = utocneC[i];
                else
                    i++;
            }


            if (z < 1)
            {
                vysledek = "Tvůj útok nebyl úspěšný";
                z = 0;
            }

            //modrak
            if (z > 0)
            {
                z = z + ut;
                vysledek = "Tvůj útok byl úspěšný";
            }
        }

        public Boj (string cil, string stavR, string stavG, string stavB, string stavY, int x)
        {
            i = 0;
            stavA = "";


            string[] hraci = { "cervenka", "zelenka", "modrak", "zlutka" };
            string[] stav = { stavR, stavG, stavB, stavY };
            
            /*
            while (stavA == "")
            {
                if ((cil != null) | (cil != ""))
                {
                    if (hraci[i] == cil)
                        stavA = stav[i];
                    else
                        i++;
                }
                
            }*/

            for (i = 0; i < 4; i++)
            {
                if ((cil != null) | (cil != ""))
                {
                    if (hraci[i] == cil)
                        stavA = stav[i];
                    else
                        i++;
                }
            }
        }
    }
}
