﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LN_01
{
    class Error
    {
        public string chybka;
        public string lovisteA, zran1, zran2;

        public Error(string sestK, string ctyriK)
        {
            if (sestK == "0" || ctyriK == "0")
            {
                chybka = "Nelze se pohnout. Nebyl proveden hod kostkami.";
            }
            else
                chybka = "";
        }

        public Error(string mistoA, string misto, int x)
        {
            if ((x> 1) & (misto == mistoA))
            {
                chybka = "Házej znovu. Na této pozici jsi již byl. Pokud jsi hodil 7, znovu klikni na tlačítko potvrdit akci a vyber jinou lokaci."; ;
            }
            else
                chybka = "";
        }

        public Error(int pocet_tahu)
        {
            if (pocet_tahu <= 5)
            {
                chybka = "Během prvního kola, nelze útočit.";
            }
            else
                chybka = "";
        }

        public Error(string aktivni, string lokaceR, string lokaceG, string lokaceB, string lokaceY)
        {
            if ((aktivni == "modrak") & (lokaceB != lokaceG) & (lokaceB != lokaceR) & (lokaceB != lokaceY))
            {
                chybka = "Nelze zaútočit. Nikdo není ve tvém lovišti.";
            }
            else if ((aktivni == "cervenka") & (lokaceR != lokaceG) & (lokaceR != lokaceB) & (lokaceR != lokaceY))
            {
                chybka = "Nelze zaútočit. Nikdo není ve tvém lovišti.";
            }
            else if ((aktivni == "zelenka") & (lokaceG != lokaceB) & (lokaceG != lokaceR) & (lokaceG != lokaceY))
            {
                chybka = "Nelze zaútočit. Nikdo není ve tvém lovišti.";
            }
            else if ((aktivni == "zlutka") & (lokaceY != lokaceG) & (lokaceY != lokaceR) & (lokaceY != lokaceB))
            {
                chybka = "Nelze zaútočit. Nikdo není ve tvém lovišti.";
            }
            else
                chybka = "";

        }

        public Error()
        {
            chybka = "Nemůžeš útočit sám na sebe. To by bylo nečestné. Zkus to znovu.";
        }

        public Error(string aktivni, string cil1, string cil2, string lovisteR, string lovisteG, string lovisteB, string lovisteY, string pistole)
        {
            zran1 = "";
            zran2 = "";

            if ((cil1 == "cervenka") | (cil2 == "cervenka"))
                if (zran1 == "")
                    zran1 = lovisteR;
                else
                    zran2 = lovisteR;

            if ((cil1 == "zelenka") | (cil2 == "zelenka"))
                if (zran1 == "")
                    zran1 = lovisteG;
                else
                    zran2 = lovisteG;

            if ((cil1 == "modrak") | (cil2 == "modrak"))
                if (zran1 == "")
                    zran1 = lovisteB;
                else
                    zran2 = lovisteB;

            if ((cil1 == "zlutka") | (cil2 == "zlutka"))
                if (zran1 == "")
                    zran1 = lovisteY;
                else
                    zran2 = lovisteY;

            if (aktivni == "cervenka")
                lovisteA = lovisteR;
            if (aktivni == "zelenka")
                lovisteA = lovisteG;
            if (aktivni == "modrak")
                lovisteA = lovisteB;
            if (aktivni == "zlutka")
                lovisteA = lovisteY;

            //reseni Pistole po prve
            if (aktivni == pistole)
            {
                if ((lovisteA == zran1) & (lovisteA == zran2))
                {
                    chybka = "Nelze zaútočit. Žádný z cílů není ve tvém lovišti.";
                }
                else
                    chybka = "";
            }
            else
            {
                if ((lovisteA != zran1) & (lovisteA != zran2))
                {
                    chybka = "Nelze zaútočit. Žádný z cílů není ve tvém lovišti.";
                }
                else
                    chybka = "";
            }


            
        }

        //hlidani aby hrac nenapadl nekoho mimo jeho loviste
        public Error(string aktivni, string cil, string lovisteR, string lovisteG, string lovisteB, string lovisteY, string pistole)
        {
            switch (cil)
            {
                case "cervenka":
                    lovisteA = lovisteR;
                    break;
                case "zelenka":
                    lovisteA = lovisteG;
                    break;
                case "zlutka":
                    lovisteA = lovisteY;
                    break;
            }

            if (pistole == aktivni)
            {
                if (lovisteB == lovisteA)
                {
                    chybka = "Tvůj cíl se nenachází ve tvém lovišti.";
                }
                else
                    chybka = "";
            }
            else
            {
                if (lovisteB != lovisteA)
                {
                    chybka = "Tvůj cíl se nenachází ve tvém lovišti.";
                }
                else
                    chybka = "";
            }


            
        }
       
        //Andel
        public Error(string aktivni, string cil, string andel)
        {
            if(cil == andel)
                chybka = "Tvůj cíl nemůže být napaden útokem, neb má Anděla strážného.";
            else
                chybka = "";
        }
    }
}
