﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

//dodavane

//velikost okna
//1225; 861

namespace LN_01
{
    public partial class Form1 : Form
    {
        //promenne
        Start zacatek = new Start();
        
        Kostka kostka;
        
        public int pocet_tahu;
        private int pocet_vyrazenych;
        public int x, y, z;

        public string lokaceA, lokaceNew;
        Color barvaA, barvaN;
        

        public string error = "";

        //pomocne promene pro mista a karty
        public int mistoHP;
        public int figurkaHP;
        public string odkladiste, akce;

        //pro urceni zraneni
        public int zran = 0;

        //zda jiz byl pripsan bonus z Kopi
        public int kopi = 0;

        //cile
        public string cil;
        public string cil1;
        public string cil2;
        public string vysledek;

        //hraci
        Hrac cervenka;
        Hrac zelenka;
        Hrac modrak;
        Hrac zlutka;
        
        //pohyb figurek po mape
        Pohyb pohyb;
        Postavy postava;
        Zraneni zraneni;
        
        //karty
        Karty karta = new Karty();
        string jmenoK, textK, typK, rasa1, rasa2, moznost1, moznost2;

        //pamet
        Pamet pamet;

        //boj
        Boj cilZran;
        Boj cilLov;
        Boj cilHled;
        Boj masakr;
        Boj overStav;

        //aktivni hrac
        public string aktivni;
        int hpA, zranA, utcA;
        string stavA, jmenoA, rasaA, mistoA, lovisteA;
        string rasaC;
        //Cil
        int hpC, zranC;

        public Form1()
        {
            
            InitializeComponent();

            //zavolam start, ktery nastavi vychozi pozici vsech prvku
            //reset planu kdyby nahodou neco
            plan.Location = new Point(205, 131);
          

            /*
            Label do ktereho se prubezne zapisuje jaka cast kola zrovna je.
            Hrac uvidi kde je a kdo je na tahu. Stejne tak AI
            */
            fazovac.Text = "Začátek hry";

            //nahodny hrac zacne dle kostky 1k4 a kazdemu cislu bude prirazena spravna barva pro fazovac
            
            //start zacatek = new start();
            fazovac.ForeColor = zacatek.barva;

            //zakladni lokace figurek
            red.Location = new Point(zacatek.f_rx, zacatek.f_y);
            green.Location = new Point(zacatek.f_gx, zacatek.f_y);
            blue.Location = new Point(zacatek.f_bx, zacatek.f_y);
            yellow.Location = new Point(zacatek.f_yx, zacatek.f_y);

            //hp
            red_hp.Location = new Point(zacatek.hp_rx, zacatek.hp_y);
            green_hp.Location = new Point(zacatek.hp_gx, zacatek.hp_y);
            blue_hp.Location = new Point(zacatek.hp_bx, zacatek.hp_y);
            yellow_hp.Location = new Point(zacatek.hp_yx, zacatek.hp_y);

            //R G Y B
            x = 0;
            y = 0;
            postava = new Postavy();
            cervenka = new Hrac("cervenka", postava.jmeno1, postava.hp1, postava.cil1,
                postava.schopnost1, postava.rasa1, Color.Red, Color.Green);

            zelenka = new Hrac("zelenka", postava.jmeno2, postava.hp2, postava.cil2,
                postava.schopnost2, postava.rasa2, Color.Green, Color.Coral);
            
            modrak = new Hrac("modrak", postava.jmeno3, postava.hp3, postava.cil3,
                postava.schopnost3, postava.rasa3, Color.Navy, Color.Red);

            zlutka = new Hrac("zlutka", postava.jmeno4, postava.hp4, postava.cil4,
                postava.schopnost4, postava.rasa4, Color.Coral, Color.Navy);

            //Nacteni dat hracu - krom modraka to staci u ostatnich az po odhaleni se
            /*
            jmenoR.Text = cervenka.jmeno;
            rasaR.Text = cervenka.rasa;
            cilR.Text = cervenka.cil;
            hpR.Text = cervenka.zivoty;
            schopnostR.Text = cervenka.schopnost;
            cervenka.pametR = cervenka.rasa;
            
            jmenoG.Text = zelenka.jmeno;
            rasaG.Text = zelenka.rasa;
            cilG.Text = zelenka.cil;
            hpG.Text = zelenka.zivoty;
            schopnostG.Text = zelenka.schopnost;
            zelenka.pametG = zelenka.rasa;
            */
            jmenoB.Text = modrak.jmeno;
            rasaB.Text = modrak.rasa;
            cilB.Text = modrak.cil;
            hpB.Text = modrak.zivoty;
            schopnostB.Text = modrak.schopnost;
            modrak.pametB = modrak.rasa;
            stavB.Text = modrak.stav;
            /*
            jmenoY.Text = zlutka.jmeno;
            rasaY.Text = zlutka.rasa;
            cilY.Text = zlutka.cil;
            hpY.Text = zlutka.zivoty;
            schopnostY.Text = zlutka.schopnost;
            zlutka.pametY = zlutka.rasa;
            */

            //Pridani do pameti vlastni rasa
            cervenka.pametR = cervenka.rasa;
            zelenka.pametG = zelenka.rasa;
            zlutka.pametY = zlutka.rasa;

        }

        //spouštěč nové hry - restart programu
        private void newG_Click(object sender, EventArgs e)
        {
            Application.Restart();
        }


        private void hazedlo_Click(object sender, EventArgs e)
        {
            //kostky
            kostka = new Kostka(6);
            sestka.Text = Convert.ToString(kostka.UK);

            kostka = new Kostka(4);
            ctyrka.Text = Convert.ToString(kostka.UK);
        }
        

        //The Mighty Button Of Doom
        /*
         * Řeší vše, pohyb, útoky, karty ....
        */
        private void tmbod_Click(object sender, EventArgs e)
        {
            #region Odhaleni
            if (cervenka.stav == "odhalen")
            {
                jmenoR.Text = cervenka.jmeno;
                rasaR.Text = cervenka.rasa;
                cilR.Text = cervenka.cil;
                hpR.Text = cervenka.zivoty;
                schopnostR.Text = cervenka.schopnost;
                cervenka.pametR = cervenka.rasa;
            }
            
            if (zelenka.stav == "odhalen")
            {
                jmenoG.Text = zelenka.jmeno;
                rasaG.Text = zelenka.rasa;
                cilG.Text = zelenka.cil;
                hpG.Text = zelenka.zivoty;
                schopnostG.Text = zelenka.schopnost;
                zelenka.pametG = zelenka.rasa;
            }

            if (zlutka.stav == "odhalen")
            {
                jmenoY.Text = zlutka.jmeno;
                rasaY.Text = zlutka.rasa;
                cilY.Text = zlutka.cil;
                hpY.Text = zlutka.zivoty;
                schopnostY.Text = zlutka.schopnost;
                zlutka.pametY = zlutka.rasa;
            }
            #endregion

            #region Aktivni hrac
            //modrak - clovek
            if ((fazovac.ForeColor == Color.Navy) & (modrak.stav != "vyrazen"))
            {
                aktivni = "modrak";
                barvaN = modrak.barvaN;
                barvaA = modrak.barvaA;
                stavB.Text = modrak.stav;
            }
            else if ((fazovac.ForeColor == Color.Navy) & (modrak.stav == "vyrazen"))
            {
                fazovac.Text = "Pohyb";
                fazovac.ForeColor = modrak.barvaN;
                blue.Location = new Point(zacatek.f_bx, zacatek.f_y);
                blue_hp.Location = new Point(zacatek.f_bx, zacatek.f_y);
                sestka.Text = "0";
                ctyrka.Text = "0";
                return;

            }

            //Cervenka
            if ((fazovac.ForeColor == Color.Red) & (cervenka.stav != "vyrazen"))
            {
                aktivni = "cervenka";
                barvaN = cervenka.barvaN;
                barvaA = cervenka.barvaA;
            }
            else if ((fazovac.ForeColor == Color.Red) & (cervenka.stav == "vyrazen"))
            {
                fazovac.Text = "Pohyb";
                fazovac.ForeColor = cervenka.barvaN;
                red.Location = new Point(zacatek.f_rx, zacatek.f_y);
                red_hp.Location = red.Location;//new Point(zacatek.f_rx, zacatek.f_y);
                sestka.Text = "0";
                ctyrka.Text = "0";
                return;
            }

            //zelenka
            if ((fazovac.ForeColor == Color.Green) & (zelenka.stav != "vyrazen"))
            {
                aktivni = "zelenka";
                barvaN = zelenka.barvaN;
                barvaA = zelenka.barvaA;
            }
            else if ((fazovac.ForeColor == Color.Green) & (zelenka.stav == "vyrazen"))
            {
                fazovac.Text = "Pohyb";
                fazovac.ForeColor = zelenka.barvaN;
                green.Location = new Point(zacatek.f_gx, zacatek.f_y);
                green_hp.Location = new Point(zacatek.f_gx, zacatek.f_y);
                sestka.Text = "0";
                ctyrka.Text = "0";
                return;

            }

            //zlutka
            if ((fazovac.ForeColor == Color.Coral) & (zlutka.stav != "vyrazen"))
            {
                aktivni = "zlutka";
                barvaN = zlutka.barvaN;
                barvaA = zlutka.barvaA;
            }
            else if ((fazovac.ForeColor == Color.Coral) & (zlutka.stav == "vyrazen"))
            {
                fazovac.Text = "Pohyb";
                //nahozeni kostek do puvodni pozice kvuli osetreni chyby
                sestka.Text = "0";
                ctyrka.Text = "0";
                fazovac.ForeColor = zlutka.barvaN;
                yellow.Location = new Point(zacatek.f_yx, zacatek.f_y);
                yellow_hp.Location = new Point(zacatek.f_yx, zacatek.f_y);
                return;
            }
            #endregion

            #region Vyrazeni
            if (modrak.stav == "vyrazen")
            {
                blue.Location = new Point(zacatek.f_bx, zacatek.f_y);
                blue_hp.Location = new Point(zacatek.f_bx, zacatek.f_y);
            }

            //Cervenka
           if(cervenka.stav == "vyrazen")
            {
                red.Location = new Point(zacatek.f_rx, zacatek.f_y);
                red_hp.Location = red.Location;
                
            }

            //zelenka
           if (zelenka.stav == "vyrazen")
            {
                green.Location = new Point(zacatek.f_gx, zacatek.f_y);
                green_hp.Location = new Point(zacatek.f_gx, zacatek.f_y);
                
            }

            //zlutka
           if  (zlutka.stav == "vyrazen")
            {
                yellow.Location = new Point(zacatek.f_yx, zacatek.f_y);
                yellow_hp.Location = new Point(zacatek.f_yx, zacatek.f_y);
            }
            #endregion


            //zjisteni hodnot aktualniho hrace
            string[] hraci = { "cervenka", "zelenka", "modrak", "zlutka" };
            string[] cile = { "cervenka", "zelenka", "modrak", "zlutka" };
            string[] jmeno = { cervenka.jmeno, zelenka.jmeno, modrak.jmeno, zlutka.jmeno };
            string[] rasa = { cervenka.rasa, zelenka.rasa, modrak.rasa, zlutka.rasa };
            string[] stav = { cervenka.stav, zelenka.stav, modrak.stav, zlutka.stav };
            string[] hp = { cervenka.zivoty, zelenka.zivoty, modrak.zivoty, zlutka.zivoty };
            string[] schopnostiT = { cervenka.schopnost, zelenka.schopnost, modrak.schopnost, zlutka.schopnost };
            int[] zran = { cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni };
            int[] utc = { cervenka.utocneC, zelenka.utocneC, modrak.utocneC, zlutka.utocneC };
            string[] loviste = { cervenka.loviste, zelenka.loviste, modrak.loviste, zlutka.loviste };
            string[] misto = { cervenka.misto, zelenka.misto, modrak.misto, zlutka.misto };
            string[] pametR = { cervenka.pametR, cervenka.pametG, cervenka.pametB, cervenka.pametY };
            string[] pametG = { zelenka.pametR, zelenka.pametG, zelenka.pametB, zelenka.pametY };
            //string[] pametB = { cervenka.pametR, cervenka.pametG, cervenka.pametB, cervenka.pametY };
            string[] pametY = { zlutka.pametR, zlutka.pametG, zlutka.pametB, zlutka.pametY };
            int[] schopnosti = {cervenka.schop, zelenka.schop, modrak.schop, zlutka.schop };

            x = 0;
            y = 0;

            while (aktivni != hraci[x])
            {
                x++;
            }

            //Volba cile tu pro AI a pripadne si ho pak dovolavat v danych sekcich? Neb cil volam na trech+ mistech
            //s aplikaci PAMETI
            switch (aktivni)
            {
                case "cervenka":
                    cilHled = new Boj(aktivni, cervenka.pametR, cervenka.pametG, cervenka.pametB, cervenka.pametY);
                    break;
                case "zelenka":
                    cilHled = new Boj(aktivni, zelenka.pametR, zelenka.pametG, zelenka.pametB, zelenka.pametY);
                    break;
                case "modrak":
                    cilHled = new Boj(aktivni, modrak.pametR, modrak.pametG, modrak.pametB, modrak.pametY);
                    break;
                case "zlutka":
                    cilHled = new Boj(aktivni, zlutka.pametR, zlutka.pametG, zlutka.pametB, zlutka.pametY);
                    break;
            }

            /*
            //hledani cile dle dostupneho infa
            cilHled = new Boj(aktivni, cervenka.rasa, zelenka.rasa, modrak.rasa, zlutka.rasa);
            cil1 = cilHled.cil1;
            cil2 = cilHled.cil2;
            */
            cil1 = cilHled.cil1;
            cil2 = cilHled.cil2;

            //vyber cile s vetsim zranenim, pokud je stejne nacti cil1
            cilZran = new Boj(cil1, cil2, cervenka.zraneni, cervenka.zraneni, modrak.zraneni, zlutka.zraneni);
            cil = cilZran.cil;

            //kolo
            if ((fazovac.Text == "Začátek hry") | (fazovac.Text == "Pohyb"))
            {
                pocet_tahu++;
                pohyb = new Pohyb(aktivni, cervenka.misto, zelenka.misto, modrak.misto, zlutka.misto);

                lokaceA = pohyb.mistoA;
                mistoHP = 0;

                //zmizeni andela
                if (aktivni == karta.modra[0, 3])
                    karta.modra[0, 3] = "1";

                //schopnost AI
                if (aktivni != "modrak")
                {

                    //Ultima
                    if ((jmeno[x] == "Ultima") & (stav[x] != "vyrazen") & (schopnosti[x] == 0) & (pocet_tahu > 8))
                    {
                        
                        while (cil1 != cile[y])
                        {
                            y++;
                        }
                        if (misto[y] == "hrbitov")
                            cil = cil1;
                        else
                        {
                            while (cil1 != cile[y])
                            {
                                y++;
                            }
                            if (misto[y] == "hrbitov")
                                cil = cil2;
                            else
                                cil = "";
                        }

                        if ((cil != "") & (stav[x] == "odhalen") & (schopnosti[x] == 0))
                            mistoHP = 3;

                        if ((cil != "") & (stav[x] != "odhalen") & (schopnosti[x] == 0))
                        {
                            stav[x] = "odhalen";
                            mistoHP = 3;
                            pametR[x] = rasa[x];
                            pametG[x] = rasa[x];
                            pametY[x] = rasa[x];

                            if (cil == "modrak")
                                MessageBox.Show("Byl jsi zraněn schopností hráče " + aktivni, "Schopnost", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                            else
                                MessageBox.Show("Hrac " + cil + " byl zasažen schopností hráče " + aktivni, "Schopnost", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                        }

                        

                    }

                    //Jedenkrát za hru smíš na začátku svého tahu zvolit jednoho hráče, jehož SCHOPNOST nebude až do konce hry platit.
                    if ((jmeno[x] == "Elektra") & (stav[x] != "vyrazen") & (schopnosti[x] == 0) & (pocet_tahu > 12))
                    {

                        y = 0;
                        while (cil1 != cile[y])
                        {
                            y++;
                        }

                        if (schopnosti[y] == 0)
                            cil = cil1;
                        else
                        {
                            y = 0;
                            while (cil2 != cile[y])
                            {
                                y++;
                            }

                            if (schopnosti[y] == 0)
                                cil = cil2;
                            else
                                cil = "";

                        }

                        if ((cil != "") & (stav[x] != "odhalen") & (schopnosti[x] == 0))
                        {
                            stav[x] = "odhalen";
                            pametR[x] = rasa[x];
                            pametG[x] = rasa[x];
                            pametY[x] = rasa[x];
                        }

                        if ((cil != "") & (stav[x] == "odhalen") & (schopnosti[x] == 0))
                        {
                            schopnosti[y] = 1;
                            schopnosti[x] = 1;
                        }



                        if ((cil == "modrak") & (schopnosti[x] == 1))
                            MessageBox.Show("Byl jsi zraněn schopností hráče " + aktivni, "Schopnost", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                        else
                            MessageBox.Show("Hrac " + cil + " byl zasažen schopností hráče " + aktivni, "Schopnost", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    //Jedenkrát za hru smíš na začátku svého tahu vybrat jednoho hráče: Hoď 1k6 kostkou a způsob vybranému hráči hozený počet zranění.
                    if (((jmeno[x] == "Fenrir") | (jmeno[x] == "Gabrin")) & (schopnosti[x] == 0) & (stav[x] != "vyrazen") & (pocet_tahu > 12))
                    {

                        //vyber cile s vetsim zranenim, pokud je stejne nacti cil1
                        cilZran = new Boj(cil1, cil2, cervenka.zraneni, cervenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        cil = cilZran.cil;

                        y = 0;

                        while (cil != cile[y])
                        {
                            y++;
                        }

                        switch (jmeno[x])
                        {
                            case "Fenrir":
                                kostka = new Kostka(6);
                                break;
                            case "Gabrin":
                                kostka = new Kostka(4);
                                break;
                        }
                        hpC = Convert.ToInt32(hp[y]);
                        hpA = Convert.ToInt32(hp[x]);


                        //odhalit se a pouzit schopnost kdyz cil ma mene jak polovinu hp a nebo ja
                        if ((stav[x] != "odhalen") & ( ( (hpA - zran[x] < hpA/2) ) | ((hpC - zran[y] < hpC / 2))))
                        {
                            stav[x] = "odhalen";
                            
                            pametR[x] = rasa[x];
                            pametG[x] = rasa[x];
                            pametY[x] = rasa[x];
                        }


                        if ((cil != "") & (stav[x] == "odhalen") & (schopnosti[x] == 0))
                        {
                            mistoHP = kostka.UK;
                            schopnosti[x] = 1;

                            if (cil == "modrak")
                                MessageBox.Show("Byl jsi zraněn schopností hráče " + aktivni, "Schopnost", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                            else
                                MessageBox.Show("Hrac " + cil + " byl zasažen schopností hráče " + aktivni, "Schopnost", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                        }

                        
                    }

                    //Jedenkrát za hru smíš na začátku svého tahu přesunout žeton libovolného hráče na políčko s krvavým měsícem (zranit/vyléčit na 7 životů) krvavy mesic
                    if ((jmeno[x] == "Freya") & (stav[x] != "vyrazen") & (schopnosti[x] == 0) & (pocet_tahu > 12))
                    {

                        y = 0;
                        x = 0;

                        while (cil1 != cile[y])
                        {
                            y++;
                        }

                        while (cil2 != cile[x])
                        {
                            x++;
                        }

                        if ((zran[y] > zran[x]) & (zran[x] < 7))
                        {
                            cil = cil2;
                        }
                        else if ((zran[x] > zran[y]) & (zran[y] < 7))
                        {
                            cil = cil1;
                        }
                        else
                        {
                            x = 0;
                            while (aktivni != hraci[x])
                            {
                                x++;
                            }
                            if (zran[x] > 7)
                                cil = aktivni;
                            else
                                cil = "";
                        }

                        x = 0;
                        while (aktivni != hraci[x])
                        {
                            x++;
                        }

                        if ((cil != "") & (stav[x] != "odhalen") & (schopnosti[x] == 0))
                        {
                            

                            stav[x] = "odhalen";
                            pametR[x] = rasa[x];
                            pametG[x] = rasa[x];
                            pametY[x] = rasa[x];
                        }


                        if ((cil != "") & (stav[x] == "odhalen") & (schopnosti[x] == 0))
                        {
                            switch (cil)
                            {
                                case "cervenka":
                                    cervenka.zraneni = 7;
                                    break;
                                case "zelenka":
                                    zelenka.zraneni = 7;
                                    break;
                                case "modrak":
                                    modrak.zraneni = 7;
                                    break;
                                case "zlutka":
                                    zlutka.zraneni = 7;
                                    break;
                            }
                            schopnosti[x] = 1;

                            if (cil == "modrak")
                                MessageBox.Show("Byl jsi zraněn schopností hráče " + aktivni, "Schopnost", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                            else if (cil != "")
                                MessageBox.Show("Hrac " + cil + " byl zasažen schopností hráče " + aktivni, "Schopnost", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                        }
                     
                        
                    }

                }


                do
                {
                    //Kompas
                    if (aktivni == karta.modra[15, 3])
                    {
                        sestka.Text = "4";
                        ctyrka.Text = "3";
                    }

                    //hod kostkami na pohyb
                    if (aktivni == "modrak")
                    {
                        Error error = new Error(sestka.Text, ctyrka.Text);

                        if (error.chybka != "")
                        {
                            MessageBox.Show(error.chybka, "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            return;
                        }
                    }
                    //reseni AI pokud nema Kompas
                    else if ((aktivni != "modrak") & (aktivni != karta.modra[15, 3]))
                    {
                        kostka = new Kostka(6);
                        sestka.Text = Convert.ToString(kostka.UK);
                        kostka = new Kostka(4);
                        ctyrka.Text = Convert.ToString(kostka.UK);
                    }

                    pohyb = new Pohyb(sestka.Text, ctyrka.Text, aktivni);
                    lokaceNew = pohyb.misto;
                    //Rozlisuje ktery error cilovat
                    x++;

                    if (aktivni == "modrak")
                    {
                        Error error = new Error(lokaceA, lokaceNew, x);

                        if (error.chybka != "")
                        {
                            MessageBox.Show(error.chybka, "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            return;
                        }
                    }

                } while (lokaceNew == lokaceA);
               
                if(lokaceNew == null)
                {
                    MessageBox.Show("Nebylo vybráno místo, kam chceš jít. Zkus to znovu a nebo hoď kostkami pro pohyb.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                switch(aktivni)
                {
                    case "cervenka":
                        red.Location = new Point(pohyb.x, pohyb.y);
                        cervenka.misto = lokaceNew;
                        break;
                    case "zelenka":
                        green.Location = new Point(pohyb.x, pohyb.y);
                        zelenka.misto = lokaceNew;
                        break;
                    case "modrak":
                        blue.Location = new Point(pohyb.x, pohyb.y);
                        modrak.misto = lokaceNew;
                        break;
                    case "zlutka":
                        yellow.Location = new Point(pohyb.x, pohyb.y);
                        zlutka.misto = lokaceNew;
                        break;
                }

                 switch (cil)
                {
                    case "cervenka":
                        cervenka.zraneni = cervenka.zraneni + mistoHP;
                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        red_hp.Location = new Point(zacatek.hp_rx, zraneni.y);
                        break;
                    case "zelenka":
                        zelenka.zraneni = zelenka.zraneni + mistoHP;
                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        green_hp.Location = new Point(zacatek.hp_gx, zraneni.y);
                        break;
                    case "modrak":
                        modrak.zraneni = modrak.zraneni + mistoHP;
                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        blue_hp.Location = new Point(zacatek.hp_bx, zraneni.y);
                        break;
                    case "zlutka":
                        zlutka.zraneni = zlutka.zraneni + mistoHP;
                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        yellow_hp.Location = new Point(zacatek.hp_yx, zraneni.y);
                        break;
                }


                //vyrazeni hrace jehoz zraneni >= jeho hp
                //chybi osetreni aby se nahazela hlaska kdyz je hrac jednou vyrazen

                //vysledek = zraneni.vyrazeni(zivR, zivG, zivB, zivY, zranR, zranG, zranB, zranY);
                zraneni = new Zraneni(Convert.ToInt32(cervenka.zivoty), Convert.ToInt32(zelenka.zivoty),
                    Convert.ToInt32(modrak.zivoty), Convert.ToInt32(zlutka.zivoty),
                    cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);

                vysledek = zraneni.vysledek;

                if (vysledek != "")
                {
                    if ((vysledek == "Červenka") & (cervenka.stav != "vyrazen"))
                    {
                        red.Location = new Point(zacatek.f_rx, zacatek.f_y);
                        red_hp.Location = new Point(zacatek.f_rx, zacatek.f_y);
                        cervenka.stav = "vyrazen";
                        cervenka.misto = "N/A";
                        cervenka.loviste = "N/A";
                        for (int i = 10; i < 16; i++)
                        {
                            if (karta.modra[i, 3] == "cervenka")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "cervenka")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    if ((vysledek == "Zelenka") & (zelenka.stav != "vyrazen"))
                    {
                        green.Location = new Point(zacatek.f_gx, zacatek.f_y);
                        green_hp.Location = new Point(zacatek.f_gx, zacatek.f_y);
                        green_hp.Location = green.Location;
                        zelenka.stav = "vyrazen";
                        zelenka.misto = "N/A";
                        zelenka.loviste = "N/A";
                        for (int i = 10; i < 16; i++)
                        {
                            if (karta.modra[i, 3] == "zelenka")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "zelenka")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    if ((vysledek == "Modrák") & (modrak.stav != "vyrazen"))
                    {
                        blue.Location = new Point(zacatek.f_bx, zacatek.f_y);
                        blue_hp.Location = new Point(zacatek.f_bx, zacatek.f_y);
                        modrak.stav = "vyrazen";
                        modrak.misto = "N/A";
                        modrak.loviste = "N/A";
                        for (int i = 10; i < 16; i++)
                        {
                            if (karta.modra[i, 3] == "modrak")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "modrak")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    if ((vysledek == "Žluťka") & (zlutka.stav != "vyrazen"))
                    {
                        yellow.Location = new Point(zacatek.f_yx, zacatek.f_y);
                        yellow_hp.Location = new Point(zacatek.f_yx, zacatek.f_y);
                        zlutka.stav = "vyrazen";
                        zlutka.misto = "N/A";
                        zlutka.loviste = "N/A";
                        for (int i = 10; i < 16; i++)
                        {
                            if (karta.modra[i, 3] == "zlutka")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "zlutka")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                }



                //stav hracu
                cervenka.stav = stav[0];
                zelenka.stav = stav[1];
                modrak.stav = stav[2];
                zlutka.stav = stav[3];

                //stav schopnosti
                cervenka.schop = schopnosti[0];
                zelenka.schop = schopnosti[1];
                modrak.schop = schopnosti[2];
                zlutka.schop = schopnosti[3];

                //RGBY
                cervenka.pametG = pametR[1];
                cervenka.pametB = pametR[2];
                cervenka.pametY = pametR[3];

                zelenka.pametR = pametG[0];
                zelenka.pametB = pametG[2];
                zelenka.pametY = pametG[3];

                zlutka.pametR = pametY[0];
                zlutka.pametG = pametY[1];
                zlutka.pametB = pametY[2];

                fazovac.Text = "Místo";

                        return;
            }

            if (fazovac.Text == "Místo")
            {
                Mista mista = new Mista(aktivni, cervenka.misto, zelenka.misto, modrak.misto, zlutka.misto, 
                    cervenka.rasa, zelenka.rasa, modrak.rasa, zlutka.rasa,
                    cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni,
                   Convert.ToInt32(cervenka.zivoty), Convert.ToInt32(zelenka.zivoty), Convert.ToInt32(modrak.zivoty), Convert.ToInt32(zlutka.zivoty),
                   pocet_tahu);

                jmenoK = "";
                typK = "";
                textK = "";
                z = 0;
                y = 0;
                x = 0;

                //modre karty
                if (mista.rozhodnuti == "modra")
                {
                    do
                    {
                        kostka = new Kostka(16);
                        x = kostka.UK - 1;
                        if (karta.modra[x, 3] == "0")
                        {
                            jmenoK = karta.modra[x, 0];
                            typK = karta.modra[x, 1];
                            textK = karta.modra[x, 2];
                            z = 1;
                        }
                        else
                            y++;

                        //osetreni navraceni karet co jsou odhozene zpet do balicku
                        if (y > 6)
                        {
                            y = 0;
                            for (y = 0; y < 16; x++)//for (x = 0; x < 15; x++)
                            {
                                if (karta.modra[y, 3] == "1")
                                    karta.modra[y, 3] = "0";
                            }
                        }

                    }
                    while (z == 0);

                    if (typK == "Jednorázové použití")
                        karta.modra[x, 3] = "1";
                    else
                        karta.modra[x, 3] = aktivni;

                    //objeveni andela
                    if (jmenoK == "Anděl strážný")
                        karta.modra[x, 3] = aktivni;

                    MessageBox.Show(textK, jmenoK, MessageBoxButtons.OK, MessageBoxIcon.Information);
                }

                //cervene karty
                if (mista.rozhodnuti == "cervena")
                {
                    do
                    {
                        kostka = new Kostka(16);
                        x = kostka.UK - 1;
                        if (karta.cervena[x, 3] == "0")
                        {
                            jmenoK = karta.cervena[x, 0];
                            typK = karta.cervena[x, 1];
                            textK = karta.cervena[x, 2];
                            z = 1;
                        }
                        else
                            y++;

                        //osetreni navraceni karet co jsou odhozene zpet do balicku
                        if (y > 6)
                        {
                            y = 0;
                            for (y = 0; y < 16; y++)
                            {
                                if (karta.cervena[y, 3] == "1")
                                    karta.cervena[y, 3] = "0";
                            }
                        }

                    }
                    while (z == 0);

                    if (typK == "Jednorázové použití")
                        karta.cervena[x, 3] = "1";
                    else
                        karta.cervena[x, 3] = aktivni;

                    MessageBox.Show(textK, jmenoK, MessageBoxButtons.OK, MessageBoxIcon.Information);
                }


                //zelena karta 
                //jmeno, text, typ, rasa1, rasa2, moznost1, moznost2, stav
                if (mista.rozhodnuti == "zelena")
                {

                    while (z == 0)
                    {
                        kostka = new Kostka(16);
                        x = kostka.UK - 1;
                        
                        if (karta.zelena[x, 7] == "0")
                        {
                            jmenoK = karta.zelena[x, 0];
                            textK = karta.zelena[x, 1];
                            typK = karta.zelena[x, 2];
                            rasa1 = karta.zelena[x, 3];
                            rasa2 = karta.zelena[x, 4];
                            moznost1 = karta.zelena[x, 5];
                            moznost2 = karta.zelena[x, 6];

                            z = 1;

                        }
                        else
                            y++;

                        //osetreni navraceni karet co jsou odhozene zpet do balicku
                        if (y > 6)
                        {
                            for (x = 0; x < 16; x++)
                            {
                                if (karta.zelena[x, 7] == "1")
                                    karta.zelena[x, 7] = "0";
                            }
                        }

                    }
                    karta.zelena[x, 7] = "1";

                    if(aktivni == "modrak")
                        MessageBox.Show(textK, jmenoK, MessageBoxButtons.OK, MessageBoxIcon.Information);
                    
                }
                
                if (mista.rozhodnuti != "")
                {


                    if ((mista.rozhodnuti != "Jednorázové použití") & (mista.rozhodnuti != "VYBAVENÍ"))
                    {
                        akce = mista.rozhodnuti;
                    }
                        

                    fazovac.Text = "Událost";
                    //nahozeni kostek do puvodni pozice kvuli osetreni chyby
                    sestka.Text = "0";
                    ctyrka.Text = "0";

                    //aktualizace stavu postav ciste pro test
                    
                    stavB.Text = modrak.stav;


                    return;
                }
                else
                {
                    fazovac.Text = "Boj";
                    //nahozeni kostek do puvodni pozice kvuli osetreni chyby
                    sestka.Text = "0";
                    ctyrka.Text = "0";
                    //aktualizace stavu postav ciste pro test
                   
                    stavB.Text = modrak.stav;
 

                    return;
                }
            }

            //Reseni Karet
            if (fazovac.Text == "Událost")
            {
                mistoHP = 0;
                figurkaHP = 0;
                cil = "";

                if (aktivni == "modrak")
                {
                    if (hr1.Checked)
                        cil = "cervenka";
                    if (hr2.Checked)
                        cil = "zelenka";
                    if (hr3.Checked)
                        cil = "modrak";
                    if (hr4.Checked)
                        cil = "zlutka";

                   /* if (cil == "")
                    {
                        MessageBox.Show("Nebyl vybran cíl. Zkus to znovu.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    */
                    overStav = new Boj(cil, cervenka.stav, zelenka.stav, modrak.stav, zlutka.stav, x);
                    if (overStav.stavA == "vyrazen")
                    {
                        MessageBox.Show("Tebou vybraný cíl, je již vyřazen, zvol jiný cíl.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                }
                else if (aktivni != "modrak")
                {/*
                    //hledani cile dle dostupneho infa
                    cil1 = cilHled.cil1;
                    cil2 = cilHled.cil2;

                    //vyber cile s vetsim zranenim, pokud je stejne nacti cil1
                    //cilZran = new Boj(cil1, cil2, cervenka.zraneni, cervenka.zraneni, modrak.zraneni, zlutka.zraneni);
                    cil = cilZran.cil;
                    */
                    //overeni zda je cil vyrazen
                    overStav = new Boj(cil, cervenka.stav, zelenka.stav, modrak.stav, zlutka.stav, x);


                    if ((overStav.stavA == "vyrazen") & (cil == cil1))
                        cil = cil2;
                    else if ((overStav.stavA == "vyrazen") & (cil == cil2))
                        cil = cil1;

                }

                //vynulovani hodnot
                mistoHP = 0;
                figurkaHP = 0;
                odkladiste = "";

                //strom
                #region Srom
                if (akce == "zranenS")
                {
                    mistoHP = 2;
                    //reseni talismanu
                    if (karta.modra[12, 3] == cil)
                    {
                        if (aktivni == "modrak")
                        {
                            MessageBox.Show("Tebou vybraný cíl má ve svém vlastnictví Brož štěstěny. Vyber si jiný cíl.", "Upozornění", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            return;
                        }
                        else
                        {
                            if (cil == cil1)
                            {
                                cil = cil2;
                                Boj overStav = new Boj(cil, cervenka.stav, zelenka.stav, modrak.stav, zlutka.stav, x);
                                if ((overStav.stavA == "vyrazen") & (cil == cil2))
                                    cil = null;
                            } 
                            else if (cil == cil2)
                                cil = cil1;
                        }
                    }
                }
                if (akce == "leceniS")
                {
                    mistoHP = -1;
                    if (aktivni != "modrak")
                        cil = aktivni;
                }
                #endregion
                //Kamenny kruh
                #region Kamenny kruh
                if ((akce == "zlodej") | (jmenoK == "Mrzutý goblin"))
                {
                    for (int i = 0; i < 4;i++)
                    {
                        for(int a = 10; a < 16; a++)
                        {
                            if (((karta.modra[a, 3] == hraci[i]) | (karta.cervena[a, 3] == hraci[i]))& hraci[i] != aktivni)
                                odkladiste = "ok";
                        }

                            
                    }

                    if ((aktivni == "modrak") & (odkladiste == "ok"))
                    {
                        Zlodej kradez = new Zlodej(aktivni, akce,
                            karta.modra[10, 3], karta.modra[11, 3], karta.modra[12, 3], karta.modra[13, 3], karta.modra[14, 3], karta.modra[15, 3],
                            karta.cervena[10, 3], karta.cervena[11, 3], karta.cervena[12, 3], karta.cervena[13, 3], karta.cervena[14, 3], karta.cervena[15, 3]);

                        kradez.ShowDialog();

                        if (kradez.barva == "modra")
                        {
                           jmenoK = karta.modra[kradez.vybrane_vybaveni, 0];
                            
                            //reseni kopi
                            if(kradez.vybrane_vybaveni == 10)
                            {
                                y = 0;
                                
                                while (karta.modra[kradez.vybrane_vybaveni,3] != hraci[y])
                                {
                                    y++;
                                }
                                if(kopi == 1)
                                {
                                    utc[y] = utc[y] - 2;
                                    kopi = 0;
                                }
                              
                            }
                            //reseni roucha
                            if (kradez.vybrane_vybaveni == 14)
                            {
                                y = 0;

                                while (karta.modra[kradez.vybrane_vybaveni, 3] != hraci[y])
                                {
                                    y++;
                                }
                                utc[y] = utc[y] + 1;

                            }

                            karta.modra[kradez.vybrane_vybaveni, 3] = aktivni;

                        }

                        if (kradez.barva == "cervena")
                        {
                            jmenoK = karta.cervena[kradez.vybrane_vybaveni, 0];

                            //reseni cervenych ut predmetu
                            if ((kradez.vybrane_vybaveni == 11)| (kradez.vybrane_vybaveni == 12) | (kradez.vybrane_vybaveni == 13))
                            {
                                y = 0;

                                while (karta.cervena[kradez.vybrane_vybaveni, 3] != hraci[y])
                                {
                                    y++;
                                }
                                utc[y] = utc[y] - 1;
       
                            }
                            karta.cervena[kradez.vybrane_vybaveni, 3] = aktivni;
                        }
                    }
                    else if((aktivni != "modrak") & (odkladiste == "ok"))
                    {
                        z = 0;
                        
                        for (int i = 10; i < 16; i++)
                        {
                            if (z == 0)
                            {
                                if ((karta.cervena[i, 3] != aktivni) & (karta.cervena[i, 3] != "0"))
                                    z = i;
                            }
                        }

                        if ((z != 0))
                        {

                            
                            if (z != 0)
                            {
                                //reseni cervenych ut predmetu
                                if ((z == 11) | (z == 12) | (z == 13))
                                {
                                    y = 0;

                                    while (karta.cervena[z, 3] != hraci[y])
                                    {
                                        y++;
                                    }
                                    utc[y] = utc[y] - 1;
                                }
                                karta.cervena[z, 3] = aktivni;
                                jmenoK = karta.cervena[z, 0];
                            }


                        }
                        else if ((z == 0))
                        {
                            for (int i = 10; i < 16; i++)
                            {
                                if (z == 0)
                                {
                                    if ((karta.modra[i, 3] != aktivni) &(karta.modra[i, 3] != "0"))
                                        z = i;
                                }

                            }

                            //reseni kopi
                            if (z == 10)
                            {
                                y = 0;

                                while (karta.modra[z, 3] != hraci[y])
                                {
                                    y++;
                                }
                                if (kopi == 1)
                                {
                                    utc[y] = utc[y] - 2;
                                    kopi = 0;
                                }

                            }
                            //reseni roucha
                            if (z == 14)
                            {
                                y = 0;

                                while (karta.modra[z, 3] != hraci[y])
                                {
                                    y++;
                                }
                                utc[y] = utc[y] + 1;

                            }
                            if(z > 0)
                            {
                                karta.modra[z, 3] = aktivni;
                                jmenoK = karta.modra[z, 0];
                            }
                            
                        }
                    }
                }
                #endregion

                #region ZELENE
                if (((typK == "A") | (typK == "B") | (typK == "C") | (typK == "D")) & (aktivni != "modrak"))
                {
                    odkladiste = "";

                    //jine cilovani teoreticky moznost pouzit uplne totozne z boje, ale pro jistotu ne
                    switch (aktivni)
                    {
                        case "cervenka":
                            pamet = new Pamet(aktivni, cervenka.pametR, cervenka.pametG, cervenka.pametB, cervenka.pametY);
                            break;
                        case "zelenka":
                            pamet = new Pamet(aktivni, zelenka.pametR, zelenka.pametG, zelenka.pametB, zelenka.pametY);
                            break;
                        /*case "modrak":
                            pamet = new Pamet(aktivni, modrak.pametR, modrak.pametG, modrak.pametB, modrak.pametY);
                            break;*/
                        case "zlutka":
                            pamet = new Pamet(aktivni, zlutka.pametR, zlutka.pametG, zlutka.pametB, zlutka.pametY);
                            break;
                    }

                    cil = pamet.cil;
                    overStav = new Boj(cil, cervenka.stav, zelenka.stav, modrak.stav, zlutka.stav, x);
                    if (overStav.stavA == "vyrazen")
                        cil = "";
                                                           
                    if (aktivni != "modrak")
                    {
                        if (cil == "")
                        {
                            cilZran = new Boj(cil1, cil2, cervenka.zraneni, cervenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            cil = cilZran.cil;

                            overStav = new Boj(cil, cervenka.stav, zelenka.stav, modrak.stav, zlutka.stav, x);


                            if ((overStav.stavA == "vyrazen") & (cil == cil1))
                                cil = cil2;
                            else if ((overStav.stavA == "vyrazen") & (cil == cil2))
                                cil = cil1;
                        }

                        if (cil == "modrak")
                            MessageBox.Show(textK, jmenoK, MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }

                    rasaC = "";
                    y = 0;
                    while (cil != hraci[y])
                    {
                        y++;
                    }
                    if ((cil != "modrak") & (aktivni != "modrak"))
                        MessageBox.Show("Hráč " + aktivni + " dal zelenou kartu hráči " + cil, "Zelená", MessageBoxButtons.OK, MessageBoxIcon.Information);


                }

                
                if (typK == "A")
                {
                    //jmeno, text, typ, rasa1, rasa2, moznost1, moznost2, stav
                    if (cil == "modrak")
                    {
                        if ((jmeno[y] == "Ursana") & (schopnosti[y] == 0))
                        {

                            UrsanaR ursanaR = new UrsanaR();
                            if (ursanaR.rasaU != null)
                            {
                                odkladiste = rasa[y];
                                rasa[y] = ursanaR.rasaU;
                            }

                        }
                    }
                    else if ((cil != "modrak") & (jmeno[y] == "Ursana") & (schopnosti[y] == 0))
                    {
                        if (stav[y] == "zahalen")
                        {
                            odkladiste = rasa[y];
                            rasa[y] = "vlkodlak";
                        }
                        if (stav[y] == "odhalen")
                        {
                            odkladiste = rasa[y];
                            string[] rasy = { "upír", "vlkodlak", "člověk" };

                            for (int i = 0; i < 3; i++)
                            {
                                if ((rasy[i] != rasa1) & (rasy[i] != rasa2))
                                    rasa[y] = rasy[i];
                            }
                        }
                    }

                    if ((rasa[y] == rasa1) | (rasa[y] == rasa2))
                    {
                        z = 0;


                        for (int i = 10; i < 16; i++)
                        {
                            if (z == 0)
                            {
                                if (karta.modra[i, 3] == cil)
                                    z = i;
                            }

                        }

                        if ((z != 0) & (cil != "modrak"))
                        {


                            //reseni kopi
                            if (z == 10)
                            {
                                y = 0;

                                while (karta.modra[z, 3] != hraci[y])
                                {
                                    y++;
                                }
                                if (kopi == 1)
                                {
                                    utc[y] = utc[y] - 2;
                                    kopi = 0;
                                }

                            }
                            //reseni roucha
                            if (z == 14)
                            {
                                y = 0;

                                while (karta.modra[z, 3] != hraci[y])
                                {
                                    y++;
                                }
                                utc[y] = utc[y] + 1;

                            }
                            karta.modra[z, 3] = aktivni;
                            jmenoK = karta.modra[z, 0];

                        }
                        else if ((z == 0) & (cil != "modrak"))
                        {
                            for (int i = 10; i < 16; i++)
                            {
                                if (z == 0)
                                {
                                    if (karta.cervena[i, 3] == cil)
                                        z = i;
                                }
                            }
                            if (z != 0)
                            {
                                //reseni cervenych ut predmetu
                                if ((z == 11) | (z == 12) | (z == 13))
                                {
                                    y = 0;

                                    while (karta.cervena[z, 3] != hraci[y])
                                    {
                                        y++;
                                    }
                                    utc[y] = utc[y] - 1;
                                    

                                }
                                karta.cervena[z, 3] = aktivni;
                                jmenoK = karta.cervena[z, 0];
                            }
                        }
                        if(cil == "modrak")
                        {
                            for (int i = 10; i < 16; i++)
                            {
                                if (z == 0)
                                {
                                    if ((karta.modra[i, 3] == cil) & (karta.cervena[i, 3] == cil))
                                        z = i;
                                }

                            }
                        }
                        

                        if (z != 0)
                        {
                            Zlodej kradez = new Zlodej(aktivni, "zelena",
                   karta.modra[10, 3], karta.modra[11, 3], karta.modra[12, 3], karta.modra[13, 3], karta.modra[14, 3], karta.modra[15, 3],
                   karta.cervena[10, 3], karta.cervena[11, 3], karta.cervena[12, 3], karta.cervena[13, 3], karta.cervena[14, 3], karta.cervena[15, 3]);

                            kradez.ShowDialog();

                            if (kradez.barva == "modra")
                            {
                                //reseni kopi
                                if (kradez.vybrane_vybaveni == 10)
                                {
                                    y = 0;

                                    while (karta.modra[kradez.vybrane_vybaveni, 3] != hraci[y])
                                    {
                                        y++;
                                    }
                                    if (kopi == 1)
                                    {
                                        utc[y] = utc[y] - 2;
                                        kopi = 0;
                                    }

                                }
                                //reseni roucha
                                if (kradez.vybrane_vybaveni == 14)
                                {
                                    y = 0;

                                    while (karta.modra[kradez.vybrane_vybaveni, 3] != hraci[y])
                                    {
                                        y++;
                                    }
                                    utc[y] = utc[y] + 1;


                                }

                                karta.modra[kradez.vybrane_vybaveni, 3] = aktivni;
                                jmenoK = karta.modra[kradez.vybrane_vybaveni, 0];

                            }

                            if (kradez.barva == "cervena")
                            {
                                jmenoK = karta.cervena[kradez.vybrane_vybaveni, 0];

                                //reseni cervenych ut predmetu
                                if ((kradez.vybrane_vybaveni == 11) | (kradez.vybrane_vybaveni == 12) | (kradez.vybrane_vybaveni == 13))
                                {
                                    y = 0;

                                    while (karta.cervena[kradez.vybrane_vybaveni, 3] != hraci[y])
                                    {
                                        y++;
                                    }
                                    utc[y] = utc[y] - 1;

                                }
                                karta.cervena[kradez.vybrane_vybaveni, 3] = aktivni;
                                jmenoK = karta.cervena[kradez.vybrane_vybaveni, 0];
                            }
                        }

                        if (z == 0)
                        {
                            mistoHP = Convert.ToInt32(moznost2);
                            z = 1;
                        }

                        if (z != 0)
                        {

                            //reseni vysledku pro aktivniho
                            if (rasa1 == rasa[y])
                                rasaC = rasa1;
                            if (rasa2 == rasa[y])
                                rasaC = rasa2;

                            if ((rasa1 == "vlkodlak") & (rasa2 == "upír"))
                                rasaC = "";
                            if (rasa1 == "člověk")
                                rasaC = rasa2;
                            if (rasa2 == "člověk")
                                rasaC = rasa1;

                            
                        }

                    }

                    //zapis do pameti
                    switch (aktivni)
                    {
                        case "cervenka":
                            pametR[y] = rasaC;
                            break;

                        case "zelenka":
                            pametG[y] = rasaC;
                            break;

                        case "zlutka":
                            pametY[y] = rasaC;
                            break;
                    }

                    if ((jmeno[y] == "Ursana") & (odkladiste != "") & (schopnosti[y] == 0))
                    {
                        rasa[y] = odkladiste;
                    }
                }

                if (typK == "B")
                {
                    //jmeno, text, typ, rasa1, moznost1, stav
                    if (cil == "modrak")
                    {
                        if ((jmeno[y] == "Ursana") & (schopnosti[y] == 0))
                        {
                            if (rasa1 == "jmena1")
                            {
                                if (MessageBox.Show("Chceš se nechat věštbou zranit?", "Ursana", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
                                    moznost1 = "0";
                            }
                            else if (rasa1 == "jmena2")
                            {
                                if (MessageBox.Show("Chceš se nechat věštbou zranit?", "Ursana", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
                                    moznost1 = "0";
                            }
                            else
                            {
                                UrsanaR ursanaR = new UrsanaR();
                                if (ursanaR.rasaU != null)
                                {
                                    odkladiste = rasa[y];
                                    rasa[y] = ursanaR.rasaU;
                                }
                            }
                        }

                    }
                    else if ((cil == "modrak") & (jmeno[y] == "Ursana") & (schopnosti[y] == 0))
                    {
                        if (stav[y] == "zahalen")
                        {
                            odkladiste = rasa[y];
                            rasa[y] = "vlkodlak";
                        }
                        if (stav[y] == "odhalen")
                        {
                            odkladiste = rasa[y];
                            string[] rasy = { "upír", "vlkodlak", "člověk" };

                            for (int i = 0; i < 3; i++)
                            {
                                if ((rasy[i] != rasa1) & (rasy[i] != rasa2))
                                    rasa[y] = rasy[i];
                            }
                        }
                        if ((rasa1 == "jmena1") | (rasa1 == "jmena2"))
                        {
                            moznost1 = "0";
                        }
                    }

                    if (rasa[y] == rasa1)
                    {
                        mistoHP = Convert.ToInt32(moznost1);

                        rasaC = rasa1;
                        //reseni vysledku pro aktivniho
                        if ((rasa1 == "vlkodlak") & (rasa2 == "upír"))
                            rasaC = "";
                        if (rasa1 == "člověk")
                            rasaC = rasa2;
                        if (rasa2 == "člověk")
                            rasaC = rasa1;
                    }

                    if (rasa1 == "jmena1")
                    {

                        if (jmeno[y].StartsWith("A") | jmeno[y].StartsWith("B") | jmeno[y].StartsWith("C")
                            | jmeno[y].StartsWith("E") | jmeno[y].StartsWith("U"))
                        {
                            mistoHP = Convert.ToInt32(moznost1);
                        }

                    }
                    if (rasa1 == "jmena2")
                    {

                        if (jmeno[y].StartsWith("D") | jmeno[y].StartsWith("F") | jmeno[y].StartsWith("G")
                            | jmeno[y].StartsWith("V") | jmeno[y].StartsWith("W"))
                        {
                            mistoHP = Convert.ToInt32(moznost1);
                        }

                    }

                    //zapis do pameti
                    switch (aktivni)
                    {
                        case "cervenka":
                            pametR[y] = rasaC;
                            break;

                        case "zelenka":
                            pametG[y] = rasaC;
                            break;

                        case "zlutka":
                            pametY[y] = rasaC;
                            break;
                    }

                    if ((jmeno[y] == "Ursana") & (odkladiste != "") & (schopnosti[y] == 0))
                    {
                        rasa[y] = odkladiste;
                    }
                }

                if (typK == "C")
                {
                    //jmeno, text, typ, rasa1, moznost1, moznost2, stav

                    if (cil == "modrak")
                    {
                        if ((jmeno[y] == "Ursana") & (schopnosti[y] == 0))
                        {

                            UrsanaR ursanaR = new UrsanaR();
                            if (ursanaR.rasaU != null)
                            {
                                odkladiste = rasa[y];
                                rasa[y] = ursanaR.rasaU;
                            }

                        }
                    }
                    else if ((cil != "modrak") & (jmeno[y] == "Ursana") & (schopnosti[y] == 0))
                    {

                        if (stav[y] == "zahalen")
                        {
                            odkladiste = rasa[y];
                            rasa[y] = "vlkodlak";
                        }
                        if (stav[y] == "odhalen")
                        {
                            odkladiste = rasa[y];
                            string[] rasy = { "upír", "vlkodlak", "člověk" };

                            for (int i = 0; i < 3; i++)
                            {
                                if (rasy[i] != rasa1)
                                    rasa[y] = rasy[i];
                            }
                        }


                    }

                    if (rasa[y] == rasa1)
                    {
                        if (zran[y] == 0)
                            mistoHP = Convert.ToInt32(moznost1);
                        else
                            mistoHP = Convert.ToInt32(moznost2);

                        rasaC = rasa1;

                        //reseni vysledku pro aktivniho
                        if ((rasa1 == "vlkodlak") & (rasa2 == "upír"))
                            rasaC = "";
                        if (rasa1 == "člověk")
                            rasaC = rasa2;
                        if (rasa2 == "člověk")
                            rasaC = rasa1;
                        

                    }

                    //zapis do pameti
                    switch (aktivni)
                    {
                        case "cervenka":
                            pametR[y] = rasaC;
                            break;

                        case "zelenka":
                            pametG[y] = rasaC;
                            break;

                        case "zlutka":
                            pametY[y] = rasaC;
                            break;
                    }

                    if ((jmeno[y] == "Ursana") & (odkladiste != "") & (schopnosti[y] == 0))
                    {
                        rasa[y] = odkladiste;
                    }
                }

                if (typK == "D")
                {
                    y = 0;
                    string cilR = "";
                    //{"Poustevníkovo proroctví", "Musíš tajně ukázat svou kartu Postavy aktuálnímu hráči!", "0" },
                    switch (aktivni)
                    {
                        case "cervenka":
                            pametR[y] = rasa[y];
                            break;

                        case "zelenka":
                            pametG[y] = rasa[y];
                            break;

                        case "modrak":
                            if (rasa[y] == "upír")
                                cilR = "Všichni VLKODLACI jsou vyřazeni!";
                            if (rasa[y] == "vlkodlak")
                                cilR = "Všichni UPÍŘI jsou vyřazeni!";

                            MessageBox.Show("Jméno: " + jmeno[y] + "\n Rasa: " + rasa[y] + "\n Životy: " + hp[y] + "\n Cíl: " + cilR + "\n Schopnost: " + schopnostiT[y], jmenoK, MessageBoxButtons.OK, MessageBoxIcon.Information);
                            break;

                        case "zlutka":
                            pametY[y] = rasa[y];
                            break;
                    }


                }
                #endregion

                #region CERVENE
                //CERVENE
                //pekelny obrad
                if (jmenoK == "Pekelný obřad")
                {
                    x = 0;

                    while (aktivni != hraci[x])
                    {
                        x++;
                    }

                    stavA = stav[x];
                    hpA = Convert.ToInt32(hp[x]);
                    zranA = zran[x];
                    rasaA = rasa[x];

                    //overeni rasy
                    if (rasaA == "upír")
                    {
                        //AI
                        if (aktivni != "modrak")
                        {
                            //Odhali se pokud jeho zraneni presahuji ci rovnaji se polovine jeho zivotu
                            if ((zranA >= (hpA / 2)) & (stavA != "odhalen"))
                            {
                                stavA = "odhalen";
                                stav[x] = stavA;
                            }
                        }

                        //Pokud je hrac odhalen a splnuje podminku je vylecen
                        if (stavA == "odhalen")
                        {
                            mistoHP = -zranA;
                            cil = aktivni;
                        }

                    }

                    cervenka.stav = stav[0];
                    zelenka.stav = stav[1];
                    modrak.stav = stav[2];
                    zlutka.stav = stav[3];

                }

                if (jmenoK == "Banánová slupka")
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int a = 10; a < 16; a++)
                        {
                            if ((karta.modra[a, 3] == hraci[i]) | (karta.cervena[a, 3] == hraci[i]))
                                odkladiste = "ok";
                        }


                    }

                    if ((aktivni == "modrak") & (odkladiste == "ok"))
                    {
                        Zlodej kradez = new Zlodej(aktivni, "zelena",
                            karta.modra[10, 3], karta.modra[11, 3], karta.modra[12, 3], karta.modra[13, 3], karta.modra[14, 3], karta.modra[15, 3],
                            karta.cervena[10, 3], karta.cervena[11, 3], karta.cervena[12, 3], karta.cervena[13, 3], karta.cervena[14, 3], karta.cervena[15, 3]);

                        kradez.ShowDialog();

                        if (kradez.barva == "modra")
                        {
                            jmenoK = karta.modra[kradez.vybrane_vybaveni, 0];

                            //reseni kopi
                            if (kradez.vybrane_vybaveni == 10)
                            {
                                y = 0;

                                while (karta.modra[kradez.vybrane_vybaveni, 3] != hraci[y])
                                {
                                    y++;
                                }
                                if (kopi == 1)
                                {
                                    utc[y] = utc[y] - 2;
                                    kopi = 0;
                                }

                            }
                            //reseni roucha
                            if (kradez.vybrane_vybaveni == 14)
                            {
                                y = 0;

                                while (karta.modra[kradez.vybrane_vybaveni, 3] != hraci[y])
                                {
                                    y++;
                                }
                                utc[y] = utc[y] + 1;

                            }

                            karta.modra[kradez.vybrane_vybaveni, 3] = cil;

                        }

                        if (kradez.barva == "cervena")
                        {
                            jmenoK = karta.cervena[kradez.vybrane_vybaveni, 0];

                            //reseni cervenych ut predmetu
                            if ((kradez.vybrane_vybaveni == 11) | (kradez.vybrane_vybaveni == 12) | (kradez.vybrane_vybaveni == 13))
                            {
                                x = 0;

                                while (karta.cervena[kradez.vybrane_vybaveni, 3] != hraci[x])
                                {
                                    x++;
                                }
                                utc[y] = utc[y] + 1;


                            }
                            karta.cervena[kradez.vybrane_vybaveni, 3] = cil;
                        }
                        

                    }
                    else if ((aktivni != "modrak") & (odkladiste == "ok"))
                    {
                        cil = "";
                        y = 0;
                        while (cil != "")
                        {
                            if ((cil1 != hraci[y]) & (cil2 != hraci[y]))
                                cil = hraci[y];
                            else if (y > 4)
                            {
                                y = 0;
                                for (int i = 0; i < 4; i++)
                                {

                                    if (aktivni != hraci[y])
                                        cil = hraci[y];
                                    else
                                        y++;
                                }

                            }
                            else
                                y++;
                        }



                        z = 0;

                        for (int i = 10; i < 16; i++)
                        {
                            if (z == 0)
                            {
                                if (karta.cervena[i, 3] == cil)
                                    z = i;
                            }
                        }

                        if ((z != 0) & (cil != "modrak"))
                        {


                            if (z != 0)
                            {
                                //reseni cervenych ut predmetu
                                if ((z == 11) | (z == 12) | (z == 13))
                                {
                                    y = 0;

                                    while (karta.cervena[z, 3] != hraci[y])
                                    {
                                        y++;
                                    }
                                    utc[y] = utc[y] - 1;
                                }
                                karta.cervena[z, 3] = aktivni;
                                jmenoK = karta.cervena[z, 0];
                            }


                        }
                        else if ((z == 0) & (cil != "modrak"))
                        {
                            for (int i = 10; i < 16; i++)
                            {
                                if (z == 0)
                                {
                                    if (karta.modra[i, 3] == cil)
                                        z = i;
                                }

                            }

                            //reseni kopi
                            if (z == 10)
                            {
                                y = 0;

                                while (karta.modra[z, 3] != hraci[y])
                                {
                                    y++;
                                }
                                if (kopi == 1)
                                {
                                    utc[y] = utc[y] - 2;
                                    kopi = 0;
                                }

                            }
                            //reseni roucha
                            if (z == 14)
                            {
                                y = 0;

                                while (karta.modra[z, 3] != hraci[y])
                                {
                                    y++;
                                }
                                utc[y] = utc[y] + 1;

                            }
                            if (z > 0)
                            {
                                karta.modra[z, 3] = aktivni;
                                jmenoK = karta.modra[z, 0];
                            }
                        }

                    }
                    else
                        mistoHP = 1;
                }
                if (jmenoK == "Netopýr")
                {
                    mistoHP = 2;
                    figurkaHP = -1;

                    //reseni talismanu
                    if (karta.modra[13, 3] == cil)
                    {
                        if (aktivni == "modrak")
                        {
                            MessageBox.Show("Tebou vybraný cíl má ve svém vlastnictví Talisman. Vyber si jiný cíl.", "Upozornění", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            return;
                        }
                        else
                        {
                            if (cil == cil1)
                                cil = cil2;
                            else if (cil == cil2)
                                cil = cil1;
                        }
                    }
                }

                if (jmenoK == "Krvežíznivý pavouk")
                {
                    mistoHP = 2;
                    figurkaHP = 2;

                    //reseni talismanu
                    if (karta.modra[13, 3] == cil)
                    {
                        if (aktivni == "modrak")
                        {
                            MessageBox.Show("Tebou vybraný cíl má ve svém vlastnictví Talisman. Vyber si jiný cíl.", "Upozornění", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            return;
                        }
                        else
                        {
                            if (cil == cil1)
                                cil = cil2;
                            else if (cil == cil2)
                                cil = cil1;
                        }
                    }
                }

                if (jmenoK == "Duševní loutka")
                {
                    kostka = new Kostka(6);
                    x = kostka.UK;
                    if (x > 4)
                        cil = aktivni;

                    mistoHP = 2;
                    sestka.Text = Convert.ToString(x);


                    MessageBox.Show("Zranen byl hrac " + cil, jmenoK, MessageBoxButtons.OK, MessageBoxIcon.Information);

                }
                //Dynamit
                //hod kostkou, urceni lokace, zraneni hraci pokud jsou na lokaci, pokud ma hrac talisman je zraneni 0
                if (jmenoK == "Dynamit")
                {
                    kostka = new Kostka(6);
                    x = kostka.UK;
                    kostka = new Kostka(4);
                    y = kostka.UK + x;

                    if ((y == 2) | (y == 3))
                        mistoA = "vestkyne";
                    if ((y == 4) | (y == 5))
                        mistoA = "prameny";
                    if (y == 6)
                        mistoA = "kostel";
                    if (y == 7)
                        mistoA = null;
                    if (y == 8)
                        mistoA = "hrbitov";
                    if (y == 9)
                        mistoA = "les";
                    if (y == 10)
                        mistoA = "kruh";

                    x = 2;
                    y = 0;

                    if (mistoA == cervenka.misto)
                        cervenka.zraneni = cervenka.zraneni + x;
                    if (karta.modra[13, 3] == "cervenka")
                        cervenka.zraneni = cervenka.zraneni + y;

                    if (mistoA == zelenka.misto)
                        zelenka.zraneni = zelenka.zraneni + x;
                    if (karta.modra[13, 3] == "zelenka")
                        zelenka.zraneni = zelenka.zraneni + y;

                    if (mistoA == modrak.misto)
                        modrak.zraneni = modrak.zraneni + x;
                    if (karta.modra[13, 3] == "modrak")
                        modrak.zraneni = modrak.zraneni + y;

                    if (mistoA == zlutka.misto)
                        zlutka.zraneni = zlutka.zraneni + x;
                    if (karta.modra[13, 3] == "zlutka")
                        zlutka.zraneni = zlutka.zraneni + y;

                    vysledek = ("Dynamit vybouchl na poli " + mistoA + ".");

                    if (mistoA == null)
                        vysledek = "Padla sedmicka, zadny vybuch se nekoná.";

                    MessageBox.Show(vysledek, "Vyhodnocení", MessageBoxButtons.OK, MessageBoxIcon.Information);

                    cil = "all";
                }


                //VYBAVENI
                if ((jmenoK == "Sekáček na maso") | (jmenoK == "Řetězová pila") | (jmenoK == "Zrezivělá tesařská sekera"))
                {
                    x = 0;

                    while (aktivni != hraci[x])
                    {
                        x++;
                    }

                    utc[x] = utc[x] + 1;
                    /*
                    cervenka.utocneC = utc[0];
                    zelenka.utocneC = utc[1];
                    modrak.utocneC = utc[2];
                    zlutka.utocneC = utc[3];
                    */
                }

                //Kulomet - OK boj
                //Pistole - asi se bude resit v boji pri vyberu loviste
                //Pochoden - OK boj
                #endregion

                #region MODRE
                //MODRE
                //Andel strazny - OK

                //Vybuch spravedlnosti
                if (jmenoK == "Výbuch spravedlnosti")
                {
                    int r = 2;
                    int g = 2;
                    int b = 2;
                    int y = 2;

                    if (aktivni == "cervenka")
                        r = 0;
                    if (aktivni == "zelenka")
                        g = 0;
                    if (aktivni == "modrak")
                        b = 0;
                    if (aktivni == "zlutka")
                        y = 0;

                    cervenka.zraneni = cervenka.zraneni + r;
                    zelenka.zraneni = zelenka.zraneni + g;
                    modrak.zraneni = modrak.zraneni + b;
                    zlutka.zraneni = zlutka.zraneni + y;

                    cil = "all";
                }

                //svecena voda
                if (jmenoK == "Léčivá svěcená voda")
                {
                    mistoHP = -2;
                    cil = aktivni;
                }

                //zjeveni
                if (jmenoK == "Zjevení")
                {
                    x = 0;

                    while (aktivni != hraci[x])
                    {
                        x++;
                    }

                    stavA = stav[x];
                    hpA = Convert.ToInt32(hp[x]);
                    zranA = zran[x];
                    rasaA = rasa[x];

                    //overeni rasy
                    if (rasaA == "vlkodlak")
                    {
                        //AI
                        if (aktivni != "modrak")
                        {
                            //Odhali se pokud jeho zraneni presahuji ci rovnaji se polovine jeho zivotu
                            if ((zranA >= (hpA / 2)) & (stavA != "odhalen"))
                            {
                                stavA = "odhalen";
                                stav[x] = stavA;
                            }



                        }

                        //Pokud je hrac odhalen a splnuje podminku je vylecen
                        if (stavA == "odhalen")
                        {
                            mistoHP = -zranA;
                            cil = aktivni;
                        }

                    }

                    cervenka.stav = stav[0];
                    zelenka.stav = stav[1];
                    modrak.stav = stav[2];
                    zlutka.stav = stav[3];

                }
                //zrcadlo
                if (jmenoK == "Zrcadlo odčarování")
                {
                    if ((aktivni == "cervenka") & (cervenka.jmeno != "Ursana"))
                        cervenka.stav = "odhalen";
                    if ((aktivni == "zelenka") & (zelenka.jmeno != "Ursana"))
                        zelenka.stav = "odhalen";
                    if ((aktivni == "modrak") & (modrak.jmeno != "Ursana"))
                        modrak.stav = "odhalen";
                    if ((aktivni == "zlutka") & (zlutka.jmeno != "Ursana"))
                        zlutka.stav = "odhalen";
                }

                //Krvavy uplnek 
                if (jmenoK == "Krvavý úplněk")
                {
                    if (aktivni != "modrak")
                    {
                        y = 0;
                        x = 0;

                        while (cil1 != cile[y])
                        {
                            y++;
                        }

                        while (cil2 != cile[x])
                        {
                            x++;
                        }

                        if ((zran[y] > zran[x]) & (zran[x] < 7))
                        {
                            cil = cil2;
                        }
                        else if ((zran[x] > zran[y]) & (zran[y] < 7))
                        {
                            cil = cil1;
                        }
                        else
                        {
                            //moznost ze se nic nestane?
                            x = 0;
                            while (aktivni != hraci[x])
                            {
                                x++;
                            }
                            if (zran[x] > 7)
                                cil = aktivni;                       
                        }
                       
                    }

                    switch (cil)
                    {
                        case "cervenka":
                            cervenka.zraneni = 7;
                            break;
                        case "zelenka":
                            zelenka.zraneni = 7;
                            break;
                        case "modrak":
                            modrak.zraneni = 7;
                            break;
                        case "zlutka":
                            zlutka.zraneni = 7;
                            break;
                    }

                }

                //Pozehnani
                if (jmenoK == "Požehnání")
                {
                    kostka = new Kostka(6);
                    x = kostka.UK;
                    y = 0;

                    if (aktivni != "modrak")
                    {

                        //string[] hraci = { "cervenka", "zelenka", "modrak", "zlutka" };

                        while (cil == "")
                        {

                            if ((hraci[y] != cil1) | (hraci[y] != cil1) | (hraci[y] != aktivni))
                                cil = hraci[y];
                            else
                                y++;
                        }

                    }

                    if ((aktivni == "modrak") & (cil == "modrak"))
                    {
                        MessageBox.Show("Nemůžes cílovat sám sebe. Vyber si jiný cíl.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }

                    mistoHP = -x;

                }

                //Utajene vedomosti
                if (jmenoK == "Utajené vědomosti")
                {
                    odkladiste = "nove_kolo";
                }

                //Cokolada
                if (jmenoK == "Čokoláda")
                {
                    x = 0;

                    while (aktivni != hraci[x])
                    {
                        x++;
                    }

                    stavA = stav[x];
                    hpA = Convert.ToInt32(hp[x]);
                    zranA = zran[x];
                    jmenoA = jmeno[x];

                    //overeni jmena
                    if ((jmenoA == "Elena") | (jmenoA == "Elektra") | (jmenoA == "Ultima") | (jmenoA == "Ursana"))
                    {
                        //AI
                        if (aktivni != "modrak")
                        {
                            //Odhali se pokud jeho zraneni presahuji ci rovnaji se polovine jeho zivotu
                            if ((zranA >= (hpA / 2)) & (stavA != "odhalen"))
                            {
                                stavA = "odhalen";
                                stav[x] = stavA;
                            }



                        }

                        //Pokud je hrac odhalen a splnuje podminku je vylecen
                        if (stavA == "odhalen")
                        {
                            mistoHP = -zranA;
                            cil = aktivni;
                        }

                    }

                    cervenka.stav = stav[0];
                    zelenka.stav = stav[1];
                    modrak.stav = stav[2];
                    zlutka.stav = stav[3];

                }
                //VYBAVENI
                //Kopi
                if(jmenoK == "Longinovo kopí")
                {
                    x = 0;

                    while (aktivni != hraci[x])
                    {
                        x++;
                    }

                    utcA = utc[x];
                    rasaA = rasa[x];

                    //overeni rasy
                    if (rasaA == "vlkodlak")
                    {
                        //AI
                        //Pokud je hrac odhalen a splnuje podminku 
                        if (stavA == "odhalen")
                        {
                            utc[x] = utc[x] + 2;
                            kopi = 1;
                        }

                    }

                    cervenka.utocneC = utc[0];
                    zelenka.utocneC = utc[1];
                    modrak.utocneC = utc[2];
                    zlutka.utocneC = utc[3];
                }

                //Roucho - tu se resi jen cast tykajici se vlastnika v boji ta tykajici se utocnika 
                if (jmenoK == "Svaté roucho")
                {
                    if (aktivni == "cervenka")
                        cervenka.utocneC = cervenka.utocneC - 1;
                    if (aktivni == "zelenka")
                        zelenka.utocneC = zelenka.utocneC - 1;
                    if (aktivni == "modrak")
                        modrak.utocneC = modrak.utocneC - 1;
                    if (aktivni == "zlutka")
                        zlutka.utocneC = zlutka.utocneC - 1;
                }
                //Talisman - OK
                //Broz - OK
                //kompas - OK
                //ruzenec - OK
                #endregion

               


                //RGBY
                cervenka.pametG = pametR[1];
                cervenka.pametB = pametR[2];
                cervenka.pametY = pametR[3];

                zelenka.pametR = pametG[0];
                zelenka.pametB = pametG[2];
                zelenka.pametY = pametG[3];

                zlutka.pametR = pametY[0];
                zlutka.pametG = pametY[1];
                zlutka.pametB = pametY[2];
                

                //inventare
                itemR11.Text = "";
                itemG11.Text = "";
                itemB11.Text = "";
                itemY11.Text = "";
                for (int i = 0; i < 16; i++)
                {
                   
                    if (karta.modra[i, 3] == "cervenka")
                        itemR11.Text = itemR11.Text + ", " + karta.modra[i, 0];
                    if (karta.cervena[i, 3] == "cervenka")
                        itemR11.Text = itemR11.Text + ", " + karta.cervena[i, 0];

                    if (karta.modra[i, 3] == "zelenka")
                        itemG11.Text = itemG11.Text + ", " + karta.modra[i, 0];
                    if (karta.cervena[i, 3] == "zelenka")
                        itemG11.Text = itemG11.Text + ", " + karta.cervena[i, 0];

                    if (karta.modra[i, 3] == "modrak")
                        itemB11.Text = itemB11.Text + ", " + karta.modra[i, 0];
                    if (karta.cervena[i, 3] == "modrak")
                        itemB11.Text = itemB11.Text + ", " + karta.cervena[i, 0];

                    if (karta.modra[i, 3] == "zlutka")
                        itemY11.Text = itemY11.Text + ", " + karta.modra[i, 0];
                    if (karta.cervena[i, 3] == "zlutka")
                        itemY11.Text = itemY11.Text + ", " + karta.cervena[i, 0];
                }

                cervenka.utocneC = utc[0];
                zelenka.utocneC = utc[1];
                modrak.utocneC = utc[2];
                zlutka.utocneC = utc[3];

                //nulace zraneni pokud jsou niz nez je 0
                if (cervenka.zraneni < 0)
                    cervenka.zraneni = 0;
                if (zelenka.zraneni < 0)
                    zelenka.zraneni = 0;
                if (modrak.zraneni < 0)
                    modrak.zraneni = 0;
                if (zlutka.zraneni < 0)
                    zlutka.zraneni = 0;

                #region cil komplet
                switch (cil)
                {
                    case "cervenka":
                        cervenka.zraneni = cervenka.zraneni + mistoHP;
                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        red_hp.Location = new Point(zacatek.hp_rx, zraneni.y);
                        break;
                    case "zelenka":
                        zelenka.zraneni = zelenka.zraneni + mistoHP;
                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        green_hp.Location = new Point(zacatek.hp_gx, zraneni.y);
                        break;
                    case "modrak":
                        modrak.zraneni = modrak.zraneni + mistoHP;
                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        blue_hp.Location = new Point(zacatek.hp_bx, zraneni.y);
                        break;
                    case "zlutka":
                        zlutka.zraneni = zlutka.zraneni + mistoHP;
                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        yellow_hp.Location = new Point(zacatek.hp_yx, zraneni.y);
                        break;
                }

                //zapis zraneni aktivnimu hraci pokud nejake je a aktivni hrac nemuze byt cilem
                switch (aktivni)
                {
                    case "cervenka":
                        cervenka.zraneni = cervenka.zraneni + figurkaHP;
                        zraneni = new Zraneni(aktivni, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        red_hp.Location = new Point(zacatek.hp_rx, zraneni.y);
                        break;
                    case "zelenka":
                        zelenka.zraneni = zelenka.zraneni + figurkaHP;
                        zraneni = new Zraneni(aktivni, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        green_hp.Location = new Point(zacatek.hp_gx, zraneni.y);
                        break;
                    case "modrak":
                        modrak.zraneni = modrak.zraneni + figurkaHP;
                        zraneni = new Zraneni(aktivni, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        blue_hp.Location = new Point(zacatek.hp_bx, zraneni.y);
                        break;
                    case "zlutka":
                        zlutka.zraneni = zlutka.zraneni + figurkaHP;
                        zraneni = new Zraneni(aktivni, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        yellow_hp.Location = new Point(zacatek.hp_yx, zraneni.y);
                        break;
                }

                //vybuch spravedlnosti reseni a dynamitu
                if(cil == "all")
                {
                    cil = "cervenka";
                    zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                    red_hp.Location = new Point(zacatek.hp_rx, zraneni.y);

                    cil = "zelenka";
                    zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                    green_hp.Location = new Point(zacatek.hp_gx, zraneni.y);

                    cil = "modrak";
                    zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                    blue_hp.Location = new Point(zacatek.hp_bx, zraneni.y);

                    cil = "zlutka";
                    zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                    yellow_hp.Location = new Point(zacatek.hp_yx, zraneni.y);
                }
                #endregion

                //vysledek = zraneni.vyrazeni(zivR, zivG, zivB, zivY, zranR, zranG, zranB, zranY);
                zraneni = new Zraneni(Convert.ToInt32(cervenka.zivoty), Convert.ToInt32(zelenka.zivoty),
                    Convert.ToInt32(modrak.zivoty), Convert.ToInt32(zlutka.zivoty),
                    cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);

                vysledek = zraneni.vysledek;

                if (vysledek != "")
                {
                    if ((vysledek == "Červenka") & (cervenka.stav != "vyrazen"))
                    {
                        red.Location = new Point(zacatek.f_rx, zacatek.f_y);
                        red_hp.Location = new Point(zacatek.f_rx, zacatek.f_y);
                        cervenka.stav = "vyrazen";
                        cervenka.misto = "N/A";
                        cervenka.loviste = "N/A";
                        for (int i = 10; i < 16; i++)
                        {
                            if (karta.modra[i, 3] == "cervenka")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "cervenka")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    if ((vysledek == "Zelenka") & (zelenka.stav != "vyrazen"))
                    {
                        green.Location = new Point(zacatek.f_gx, zacatek.f_y);
                        green_hp.Location = new Point(zacatek.f_gx, zacatek.f_y);
                        green_hp.Location = green.Location;
                        zelenka.stav = "vyrazen";
                        zelenka.misto = "N/A";
                        zelenka.loviste = "N/A";
                        for (int i = 10; i < 16; i++)
                        {
                            if (karta.modra[i, 3] == "zelenka")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "zelenka")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    if ((vysledek == "Modrák") & (modrak.stav != "vyrazen"))
                    {
                        blue.Location = new Point(zacatek.f_bx, zacatek.f_y);
                        blue_hp.Location = new Point(zacatek.f_bx, zacatek.f_y);
                        modrak.stav = "vyrazen";
                        modrak.misto = "N/A";
                        modrak.loviste = "N/A";
                        for (int i = 10; i < 16; i++)
                        {
                            if (karta.modra[i, 3] == "modrak")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "modrak")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    if ((vysledek == "Žluťka") & (zlutka.stav != "vyrazen"))
                    {
                        yellow.Location = new Point(zacatek.f_yx, zacatek.f_y);
                        yellow_hp.Location = new Point(zacatek.f_yx, zacatek.f_y);
                        zlutka.stav = "vyrazen";
                        zlutka.misto = "N/A";
                        zlutka.loviste = "N/A";
                        for (int i = 10; i < 16; i++)
                        {
                            if (karta.modra[i, 3] == "zlutka")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "zlutka")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }


                }

                /*
                //stav hracu
                cervenka.stav = stav[0];
                zelenka.stav = stav[1];
                modrak.stav = stav[2];
                zlutka.stav = stav[3];

                //stav schopnosti
                cervenka.schop = schopnosti[0];
                zelenka.schop = schopnosti[1];
                modrak.schop = schopnosti[2];
                zlutka.schop = schopnosti[3];
                */


                fazovac.Text = "Boj";
                //nahozeni kostek do puvodni pozice kvuli osetreni chyby
                sestka.Text = "0";
                ctyrka.Text = "0";
                //nulace vyberu
                hr1.Checked = false;
                hr2.Checked = false;
                hr3.Checked = false;
                hr4.Checked = false;


                //aktualizace stavu postav ciste pro test
                
                stavB.Text = modrak.stav;


                return;

            }

            if (fazovac.Text == "Boj")
            {
                //nulace promenych
                cil = "";
                cil1 = "";
                cil2 = "";
                //masakr.z = 0;
                //urceni statu aktivniho hrace
                x = 0;
                ////urceni statu cile hrace
                y = 0;

                /*
                while (aktivni != hraci[x])
                {
                    x++;
                }
                */
                
               

                //v prvnim kole nelze utocit
                Error error = new Error(pocet_tahu);
                if (error.chybka != "")
                {
                    fazovac.Text = "Konec kola";

                    //reseni kdyz je na tahu hrac
                    if ((aktivni == "modrak") & (hr1.Checked | hr2.Checked | hr3.Checked))
                    {
                        MessageBox.Show(error.chybka, "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        hr1.Checked = false;
                        hr2.Checked = false;
                        hr4.Checked = false;
                    }
                    return;

                }

                //urceni lovist vsech postav
                pohyb = new Pohyb(cervenka.misto, zelenka.misto, modrak.misto, zlutka.misto);
                cervenka.loviste = pohyb.lokaceR;
                zelenka.loviste = pohyb.lokaceG;
                modrak.loviste = pohyb.lokaceB;
                zlutka.loviste = pohyb.lokaceY;

                //osetreni zda je nekdo v tvem lovisti pokud aktivni nema Pistol, je urcita sance ze i pri Pistoli nikdo nebude v Lovisti, ale s tim se poperu pak
                if (aktivni != karta.cervena[15, 3])
                {

                    error = new Error(aktivni, cervenka.loviste, zelenka.loviste, modrak.loviste, zlutka.loviste);

                    if (error.chybka != "")
                    {
                        fazovac.Text = "Konec kola";
                        //reseni kdyz je na tahu hrac
                        if ((aktivni == "modrak") & (hr1.Checked | hr2.Checked | hr3.Checked))
                        {
                            MessageBox.Show(error.chybka, "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            hr1.Checked = false;
                            hr2.Checked = false;
                            hr3.Checked = false;
                            hr4.Checked = false;
                        }
                        return;
                    }
                }

                //boj hrace - Modrak
                if ((aktivni == "modrak") & (hr1.Checked | hr2.Checked | hr3.Checked | hr4.Checked))
                {
                    //nejde provest utok pokud nebylo hozeno kostkami
                    error = new Error(sestka.Text, ctyrka.Text);
                    if (error.chybka != "")
                    {
                        MessageBox.Show(error.chybka, "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    // reseni cile
                    if (hr1.Checked)
                        cil = "cervenka";
                    if (hr2.Checked)
                        cil = "zelenka";
                    if (hr4.Checked)
                        cil = "zlutka";

                    if (cil != "")
                    {
                        while (cil != cile[y])
                        {
                            y++;
                        }
                    }

                    //hrac nemuze napadnout sam sebe
                    /*if (hr3.Checked)
                        error = new Error();
                    */
                    if (hr3.Checked)
                    {
                        error = new Error();
                        MessageBox.Show(error.chybka, "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        sestka.Text = "0";
                        ctyrka.Text = "0";
                        hr3.Checked = false;

                        return;
                    }

                    //Overeni zda je cil v lovisti -----> Pistole 
                    //error = new Error(aktivni, cil, cervenka.loviste, zelenka.loviste, modrak.loviste, zlutka.loviste);
                    error = new Error(aktivni, cil, cervenka.loviste, zelenka.loviste, modrak.loviste, zlutka.loviste, karta.cervena[15, 3]);

                    if (error.chybka != "")
                    {
                        MessageBox.Show(error.chybka, "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        hr1.Checked = false;
                        hr2.Checked = false;
                        hr4.Checked = false;

                        return;
                    }
                   
                    //reseni andela pro hrace
                    error = new Error(aktivni, cil, karta.modra[0, 3]);
                    if (error.chybka != "")
                    {
                        MessageBox.Show(error.chybka, "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);

                        return;
                    }

                }
                //boj AI
                else if (aktivni != "modrak")
                {
                    cil1 = cilHled.cil1;
                    cil2 = cilHled.cil2;

                    //zjisteni zda je cil1 a cil2 jsou v mem lovisti vcetne reseni Pistole
                    error = new Error(aktivni, cil1, cil2, cervenka.loviste, zelenka.loviste, modrak.loviste, zlutka.loviste, karta.cervena[15, 3]);
                    if (error.chybka != "")
                    {
                        fazovac.Text = "Konec kola";
                        //protoze zadny cil neni v mem lovisti

                        return;
                    }

                    //reseni andela
                    error = new Error(aktivni, cil1, karta.modra[0, 3]);
                    if (error.chybka != "")
                    {
                        cil1 = "";
                    }
                    error = new Error(aktivni, cil2, karta.modra[0, 3]);
                    if (error.chybka != "")
                    {
                        cil2 = "";
                    }
                    /*
                    //vyber cile s vetsim zranenim, pokud je stejne nacti cil1
                    cilZran = new Boj(cil1, cil2, cervenka.zraneni, cervenka.zraneni, modrak.zraneni, zlutka.zraneni);
                    cil = cilZran.cil;
                    */
                    //overeni zda cil je skutecne v lovisti vcetne reseni Pistole
                    cilLov = new Boj(cil, aktivni, cervenka.loviste, zelenka.loviste, modrak.loviste, zlutka.loviste, karta.cervena[15, 3]);

                    if (cilLov.cil != cil)
                        //cilLov = new Boj(cil2, aktivni, cervenka.loviste, zelenka.loviste, modrak.loviste, zlutka.loviste);
                        cilLov = new Boj(cil2, aktivni, cervenka.loviste, zelenka.loviste, modrak.loviste, zlutka.loviste, karta.cervena[15, 3]);

                    cil = cilLov.cil;

                    if (cil == null)
                        cil = "";
                    
                    if (cil != "")
                    {
                        while (cil != cile[y])
                        {
                            y++;
                        }
                    }


                    //hod na boj
                    kostka = new Kostka(6);
                    sestka.Text = Convert.ToString(kostka.UK);
                    kostka = new Kostka(4);
                    ctyrka.Text = Convert.ToString(kostka.UK);
                }

                //Kopi po druhe
                if ((aktivni == karta.modra[10, 3]) & (kopi == 0))
                {
                    /*x = 0;

                    while (aktivni != hraci[x])
                    {
                        x++;
                    }
                    */
                    utcA = utc[x];
                    rasaA = rasa[x];

                    //overeni rasy
                    if (rasaA == "vlkodlak")
                    {
                        //Pokud je hrac odhalen a splnuje podminku 
                        if (stavA == "odhalen")
                        {
                            utc[x] = utc[x] + 2;
                            kopi = 1;
                        }

                    }

                    cervenka.utocneC = utc[0];
                    zelenka.utocneC = utc[1];
                    modrak.utocneC = utc[2];
                    zlutka.utocneC = utc[3];


                }

                //schopnosti AI před bojem, při boji atd
                if (aktivni != "modrak")
                {
                    //Valeria odhaleni
                    if ((jmeno[x] == "Valeria") & (stav[x] != "odhalen"))
                        stav[x] = "odhalen";
                    /*
                    //Wren odhaleni
                    if ((jmeno[y] == "Wren") & (stav[y] != "odhalen"))
                        stav[y] = "odhalen";
                    */


                    cervenka.stav = stav[0];
                    zelenka.stav = stav[1];
                    modrak.stav = stav[2];
                    zlutka.stav = stav[3];
                }

                //Pochoden + Valeria schopnost
                if ((aktivni == karta.cervena[14, 3]) | ((jmeno[x] == "Valeria")&(stav[x] == "odhalen") & (schopnosti[x] == 0)))
                {
                    masakr = new Boj(aktivni, ctyrka.Text,"0", cervenka.utocneC, zelenka.utocneC, modrak.utocneC,
                    zlutka.utocneC);
                }
                else
                {
                    //cil nepotrebuji - Misto nej pak prijde moznost vybrat si pravidla pro boj na zacatku hry
                    masakr = new Boj(aktivni, sestka.Text, ctyrka.Text, cervenka.utocneC, zelenka.utocneC, modrak.utocneC,
                    zlutka.utocneC);
                }
               
                //vypsani vysledku utoku pro hrace
                if ((aktivni == "modrak") & (hr1.Checked | hr2.Checked | hr3.Checked | hr4.Checked))
                {
                    MessageBox.Show(masakr.vysledek, "Výsledek útoku", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                #region Viktor
                //Viktor odhaleni AI a reseni schopnost
                if((aktivni != "modrak") & (jmeno[x] == "Viktor") & (masakr.vysledek == "Tvůj útok byl úspěšný") & (stav[x] != "odhalen"))
                {
                    stav[x] = "odhalen";
                                       
                    cervenka.stav = stav[0];
                    zelenka.stav = stav[1];
                    modrak.stav = stav[2];
                    zlutka.stav = stav[3];
                }

                if ((jmeno[x] == "Viktor") & (masakr.vysledek == "Tvůj útok byl úspěšný") & (stav[x] == "odhalen") & (schopnosti[x] == 0))
                {
                    zran[x] = zran[x] - 2;

                    cervenka.zraneni = zran[0];
                    zelenka.zraneni = zran[1];
                    modrak.zraneni = zran[2];
                    zlutka.zraneni = zran[3];
                }
                #endregion
                zranA = 0;

                //Kulomet + reseni andela z plosneho dmg
                if (cilLov != null)
                {
                    if (aktivni == karta.cervena[10, 3])
                    {

                        if ((cervenka.loviste == cilLov.lovisteA) & (aktivni != "cervenka"))
                        {
                            if (karta.modra[0, 3] == "cervenka")
                                zranA = -masakr.z;

                            cervenka.zraneni = cervenka.zraneni + masakr.z + zranA;
                        }

                        if ((zelenka.loviste == cilLov.lovisteA) & (aktivni != "zelenka"))
                        {
                            if (karta.modra[0, 3] == "zelenka")
                                zranA = -masakr.z;

                            zelenka.zraneni = zelenka.zraneni + masakr.z + zranA;
                        }

                        if ((modrak.loviste == cilLov.lovisteA) & (aktivni != "modrak"))
                        {
                            if (karta.modra[0, 3] == "modrak")
                                zranA = -masakr.z;

                            modrak.zraneni = modrak.zraneni + masakr.z + zranA;
                        }

                        if ((zlutka.loviste == cilLov.lovisteA) & (aktivni != "zlutka"))
                        {
                            if (karta.modra[0, 3] == "zlutka")
                                zranA = -masakr.z;

                            zlutka.zraneni = zlutka.zraneni + masakr.z + zranA;
                        }


                        cil = "all";
                    }
                }
                


          
                //zraneni a resit pohyb figurky dle aktualniho zraneni + reseni Roucha
                switch (cil)
                {
                    case "cervenka":
                        if (karta.modra[14, 3] == "cervenka")
                        {
                            zranA = masakr.z - 1;
                            if (zranA < 0)
                                zranA = 0;

                            cervenka.zraneni = cervenka.zraneni + zranA;
                        }
                        else
                            cervenka.zraneni = cervenka.zraneni + masakr.z;

                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        red_hp.Location = new Point(zacatek.hp_rx, zraneni.y);
                        break;
                    case "zelenka":
                        if (karta.modra[14, 3] == "zelenka")
                        {
                            zranA = masakr.z - 1;
                            if (zranA < 0)
                                zranA = 0;

                            zelenka.zraneni = zelenka.zraneni + zranA;
                        }
                        else
                            zelenka.zraneni = zelenka.zraneni + masakr.z;
                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        green_hp.Location = new Point(zacatek.hp_gx, zraneni.y);
                        break;
                    case "modrak":
                        if (karta.modra[14, 3] == "modrak")
                        {
                            zranA = masakr.z - 1;
                            if (zranA < 0)
                                zranA = 0;

                            modrak.zraneni = modrak.zraneni + zranA;
                        }
                        else
                            modrak.zraneni = modrak.zraneni + masakr.z;
                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        blue_hp.Location = new Point(zacatek.hp_bx, zraneni.y);
                        break;
                    case "zlutka":
                        if (karta.modra[14, 3] == "zlutka")
                        {
                            zranA = masakr.z - 1;
                            if (zranA < 0)
                                zranA = 0;

                            zlutka.zraneni = zlutka.zraneni + zranA;
                        }
                        else
                            zlutka.zraneni = zlutka.zraneni + masakr.z;
                        zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        yellow_hp.Location = new Point(zacatek.hp_yx, zraneni.y);
                        break;
                }

                //vysledek kulometu + reseni Roucha pro nej
                if (cil == "all")
                {
                    cil = "cervenka";
                    if (karta.modra[14, 3] == cil)
                        cervenka.zraneni = cervenka.zraneni - 1;
                    zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                    red_hp.Location = new Point(zacatek.hp_rx, zraneni.y);

                    cil = "zelenka";
                    if (karta.modra[14, 3] == cil)
                        zelenka.zraneni = zelenka.zraneni - 1;
                    zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                    green_hp.Location = new Point(zacatek.hp_gx, zraneni.y);

                    cil = "modrak";
                    if (karta.modra[14, 3] == cil)
                        modrak.zraneni = modrak.zraneni - 1;
                    zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                    blue_hp.Location = new Point(zacatek.hp_bx, zraneni.y);

                    cil = "zlutka";
                    if (karta.modra[14, 3] == cil)
                        zlutka.zraneni = zlutka.zraneni - 1;
                    zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                    yellow_hp.Location = new Point(zacatek.hp_yx, zraneni.y);

                    cil = "all";
                }

                //vice mene jen kvuli Viktorovi a jeho schopnosti
                switch (aktivni)
                {
                    case "cervenka":
                        zraneni = new Zraneni(aktivni, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        red_hp.Location = new Point(zacatek.hp_rx, zraneni.y);
                        break;
                    case "zelenka":
                        zraneni = new Zraneni(aktivni, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        green_hp.Location = new Point(zacatek.hp_gx, zraneni.y);
                        break;
                    case "modrak":
                        zraneni = new Zraneni(aktivni, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        blue_hp.Location = new Point(zacatek.hp_bx, zraneni.y);
                        break;
                    case "zlutka":
                        zraneni = new Zraneni(aktivni, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                        yellow_hp.Location = new Point(zacatek.hp_yx, zraneni.y);
                        break;
                }

                //Wren schopnost AI, nejsem si jist reakci na kulomet
                if((cil == cile[y]) & (jmeno[y] == "Wren") & (schopnosti[y] == 0) & (stav[y] != "vyrazen"))
                {
                    if (stav[y] != "odhalen")
                    {
                        stav[y] = "odhalen";

                        pametR[y] = rasa[y];
                        pametG[y] = rasa[y];
                        pametY[y] = rasa[y];
                    }
                    cil = aktivni;
                    aktivni = hraci[y];

                    //reseni andela
                    error = new Error(aktivni, cil, karta.modra[0, 3]);
                    if (error.chybka != "")
                    {
                        cil = "";
                    }

                   

                    //hod na boj
                    kostka = new Kostka(6);
                    sestka.Text = Convert.ToString(kostka.UK);
                    kostka = new Kostka(4);
                    ctyrka.Text = Convert.ToString(kostka.UK);

                    if (aktivni == karta.cervena[14, 3])
                    {
                        sestka.Text = "0";
                        masakr = new Boj(aktivni, ctyrka.Text, sestka.Text, cervenka.utocneC, zelenka.utocneC, modrak.utocneC,
                        zlutka.utocneC);
                    }
                    else
                    {
                        //cil nepotrebuji - Misto nej pak prijde moznost vybrat si pravidla pro boj na zacatku hry
                        masakr = new Boj(aktivni, sestka.Text, ctyrka.Text, cervenka.utocneC, zelenka.utocneC, modrak.utocneC,
                        zlutka.utocneC);
                    }

                    switch (cil)
                    {
                        case "cervenka":
                            if (karta.modra[14, 3] == "cervenka")
                            {
                                zranA = masakr.z - 1;
                                if (zranA < 0)
                                    zranA = 0;

                                cervenka.zraneni = cervenka.zraneni + zranA;
                            }
                            else
                                cervenka.zraneni = cervenka.zraneni + masakr.z;

                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            red_hp.Location = new Point(zacatek.hp_rx, zraneni.y);
                            break;
                        case "zelenka":
                            if (karta.modra[14, 3] == "zelenka")
                            {
                                zranA = masakr.z - 1;
                                if (zranA < 0)
                                    zranA = 0;

                                zelenka.zraneni = zelenka.zraneni + zranA;
                            }
                            else
                                zelenka.zraneni = zelenka.zraneni + masakr.z;

                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            green_hp.Location = new Point(zacatek.hp_gx, zraneni.y);
                            break;
                        case "modrak":
                            if (karta.modra[14, 3] == "modrak")
                            {
                                zranA = masakr.z - 1;
                                if (zranA < 0)
                                    zranA = 0;

                                modrak.zraneni = modrak.zraneni + zranA;
                            }
                            else
                                modrak.zraneni = modrak.zraneni + masakr.z;
                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            blue_hp.Location = new Point(zacatek.hp_bx, zraneni.y);
                            break;
                        case "zlutka":
                            if (karta.modra[14, 3] == "zlutka")
                            {
                                zranA = masakr.z - 1;
                                if (zranA < 0)
                                    zranA = 0;

                                zlutka.zraneni = zlutka.zraneni + zranA;
                            }
                            else
                                zlutka.zraneni = zlutka.zraneni + masakr.z;
                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            yellow_hp.Location = new Point(zacatek.hp_yx, zraneni.y);
                            break;
                    }

                    //stav hracu
                    cervenka.stav = stav[0];
                    zelenka.stav = stav[1];
                    modrak.stav = stav[2];
                    zlutka.stav = stav[3];

                    //stav schopnosti
                    cervenka.schop = schopnosti[0];
                    zelenka.schop = schopnosti[1];
                    modrak.schop = schopnosti[2];
                    zlutka.schop = schopnosti[3];

                    //RGBY
                    cervenka.pametG = pametR[1];
                    cervenka.pametB = pametR[2];
                    cervenka.pametY = pametR[3];

                    zelenka.pametR = pametG[0];
                    zelenka.pametB = pametG[2];
                    zelenka.pametY = pametG[3];

                    zlutka.pametR = pametY[0];
                    zlutka.pametG = pametY[1];
                    zlutka.pametB = pametY[2];

                    aktivni = cil;
                }

                //vyrazeni hrace jehoz zraneni >= jeho hp
                //chybi osetreni aby se nahazela hlaska kdyz je hrac jednou vyrazen

                //vysledek = zraneni.vyrazeni(zivR, zivG, zivB, zivY, zranR, zranG, zranB, zranY);
                zraneni = new Zraneni(Convert.ToInt32(cervenka.zivoty), Convert.ToInt32(zelenka.zivoty),
                    Convert.ToInt32(modrak.zivoty), Convert.ToInt32(zlutka.zivoty),
                    cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);

                vysledek = zraneni.vysledek;

                if (vysledek != "")
                {
                    if ((vysledek == "Červenka") & (cervenka.stav != "vyrazen"))
                    {
                        red.Location = new Point(zacatek.f_rx, zacatek.f_y);
                        red_hp.Location = new Point(zacatek.f_rx, zacatek.f_y);
                        cervenka.stav = "vyrazen";
                        cervenka.misto = "N/A";
                        cervenka.loviste = "N/A";
                        for(int i = 10; i<16;i++)
                        {
                            if (karta.modra[i, 3] == "cervenka")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "cervenka")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    if ((vysledek == "Zelenka") & (zelenka.stav != "vyrazen"))
                    {
                        green.Location = new Point(zacatek.f_gx, zacatek.f_y);
                        green_hp.Location = new Point(zacatek.f_gx, zacatek.f_y);
                        green_hp.Location = green.Location;
                        zelenka.stav = "vyrazen";
                        zelenka.misto = "N/A";
                        zelenka.loviste = "N/A";
                        for (int i = 10; i < 16; i++)
                        {
                            if (karta.modra[i, 3] == "zelenka")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "zelenka")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    if ((vysledek == "Modrák") & (modrak.stav != "vyrazen"))
                    {
                        blue.Location = new Point(zacatek.f_bx, zacatek.f_y);
                        blue_hp.Location = new Point(zacatek.f_bx, zacatek.f_y);
                        modrak.stav = "vyrazen";
                        modrak.misto = "N/A";
                        modrak.loviste = "N/A";
                        for (int i = 10; i < 16; i++)
                        {
                            if (karta.modra[i, 3] == "modrak")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "modrak")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                    if ((vysledek == "Žluťka") & (zlutka.stav != "vyrazen"))
                    {
                        yellow.Location = new Point(zacatek.f_yx, zacatek.f_y);
                        yellow_hp.Location = new Point(zacatek.f_yx, zacatek.f_y);
                        zlutka.stav= "vyrazen";
                        zlutka.misto = "N/A";
                        zlutka.loviste = "N/A";
                        for (int i = 10; i < 16; i++)
                        {
                            if (karta.modra[i, 3] == "zlutka")
                                karta.modra[i, 3] = "1";
                            if (karta.cervena[i, 3] == "zlutka")
                                karta.cervena[i, 3] = "1";
                        }
                        MessageBox.Show("Hráč " + vysledek + " byl vyřazen ze hry.", "Hráč vyřazen", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }


                }

                //Ruzenec
                if(aktivni == karta.modra[11,3])
                {
                    x = 0;
                    while (cil == hraci[x])
                    {
                        x++;
                    }

                    if (stav[x] == "vyrazen")
                    {
                        for (y = 0; y < 15; y++ )
                        {
                            if (karta.modra[y, 3] == cil)
                                karta.modra[y, 3] = aktivni;
                            if (karta.cervena[y, 3] == cil)
                                karta.cervena[y, 3] = aktivni;
                        }
                    }
                }

                fazovac.Text = "Konec kola";
                return;
            }

            if (fazovac.Text == "Konec kola")
            {
                //zruseni vybehu hracu
                hr1.Checked = false;
                hr2.Checked = false;
                hr3.Checked = false;
                hr4.Checked = false;

                fazovac.Text = "Pohyb";
                //nahozeni kostek do puvodni pozice kvuli osetreni chyby
                sestka.Text = "0";
                ctyrka.Text = "0";

                //reseni utajenych vedomosti pripadne schopnosti 
                if (odkladiste == "nove_kolo")
                {
                    barvaN = barvaA;
                }

                //reseni zda jiz nenastal konec hry tzn nevyhrala jedna ze stran
                int upir = 0;
                int vlkodlak = 0;
                //cervenka
                if (cervenka.stav == "vyrazen")
                {
                    if (cervenka.rasa == "upír")
                        upir++;
                    if (cervenka.rasa == "vlkodlak")
                        vlkodlak++;
                }
                //zelenka
                if (zelenka.stav == "vyrazen")
                {
                    if (zelenka.rasa == "upír")
                        upir++;
                    if (zelenka.rasa == "vlkodlak")
                        vlkodlak++;
                }
                //modrak
                if (modrak.stav == "vyrazen")
                {
                    if (modrak.rasa == "upír")
                        upir++;
                    if (modrak.rasa == "vlkodlak")
                        vlkodlak++;
                }
                //zlutka
                if (zlutka.stav == "vyrazen")
                {
                    if (zlutka.rasa == "upír")
                        upir++;
                    if (zlutka.rasa == "vlkodlak")
                        vlkodlak++;
                }

                pocet_vyrazenych = upir + vlkodlak;
                
                fazovac.ForeColor = barvaN;

                #region Aktivni hrac
                //modrak - clovek
                if ((fazovac.ForeColor == Color.Navy) & (modrak.stav != "vyrazen"))
                {
                    aktivni = "modrak";
                    barvaN = modrak.barvaN;
                    barvaA = modrak.barvaA;
                }
                else if ((fazovac.ForeColor == Color.Navy) & (modrak.stav == "vyrazen"))
                {
                    fazovac.Text = "Pohyb";
                    fazovac.ForeColor = modrak.barvaN;
                    blue.Location = new Point(zacatek.f_bx, zacatek.f_y);
                    blue_hp.Location = new Point(zacatek.f_bx, zacatek.f_y);
                    sestka.Text = "0";
                    ctyrka.Text = "0";
                    return;

                }

                //Cervenka
                if ((fazovac.ForeColor == Color.Red) & (cervenka.stav != "vyrazen"))
                {
                    aktivni = "cervenka";
                    barvaN = cervenka.barvaN;
                    barvaA = cervenka.barvaA;
                }
                else if ((fazovac.ForeColor == Color.Red) & (cervenka.stav == "vyrazen"))
                {
                    fazovac.Text = "Pohyb";
                    fazovac.ForeColor = cervenka.barvaN;
                    red.Location = new Point(zacatek.f_rx, zacatek.f_y);
                    red_hp.Location = red.Location;//new Point(zacatek.f_rx, zacatek.f_y);
                    sestka.Text = "0";
                    ctyrka.Text = "0";
                    return;
                }

                //zelenka
                if ((fazovac.ForeColor == Color.Green) & (zelenka.stav != "vyrazen"))
                {
                    aktivni = "zelenka";
                    barvaN = zelenka.barvaN;
                    barvaA = zelenka.barvaA;
                }
                else if ((fazovac.ForeColor == Color.Green) & (zelenka.stav == "vyrazen"))
                {
                    fazovac.Text = "Pohyb";
                    fazovac.ForeColor = zelenka.barvaN;
                    green.Location = new Point(zacatek.f_gx, zacatek.f_y);
                    green_hp.Location = new Point(zacatek.f_gx, zacatek.f_y);
                    sestka.Text = "0";
                    ctyrka.Text = "0";
                    return;

                }

                //zlutka
                if ((fazovac.ForeColor == Color.Coral) & (zlutka.stav != "vyrazen"))
                {
                    aktivni = "zlutka";
                    barvaN = zlutka.barvaN;
                    barvaA = zlutka.barvaA;
                }
                else if ((fazovac.ForeColor == Color.Coral) & (zlutka.stav == "vyrazen"))
                {
                    fazovac.Text = "Pohyb";
                    //nahozeni kostek do puvodni pozice kvuli osetreni chyby
                    sestka.Text = "0";
                    ctyrka.Text = "0";
                    fazovac.ForeColor = zlutka.barvaN;
                    yellow.Location = new Point(zacatek.f_yx, zacatek.f_y);
                    yellow_hp.Location = new Point(zacatek.f_yx, zacatek.f_y);
                    return;
                }
                #endregion

                //vysledek
                if (upir == 2)
                {
                    MessageBox.Show("Všichni upíři byli vyřazeni. Vyhráli vlkodlaci.", "Konec hry", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                }
                else if (vlkodlak == 2)
                {
                    MessageBox.Show("Všichni vlkodlaci byli vyřazeni. Vyhráli upíři.", "Konec hry", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                }

                stavB.Text = modrak.stav;
 

                return;
            }

        }

        private void OdhSchop_Click(object sender, EventArgs e)
        {
            if (modrak.stav == "zahalen")
            {
                modrak.stav = "odhalen";
                OdhSchop.Text = "Použij schopnost";
                cervenka.pametB = modrak.rasa;
                zelenka.pametB = modrak.rasa;
                zlutka.pametB = modrak.rasa;
                stavB.Text = modrak.stav;
                return;
            }
            /*
            * bude fungovat vlastne stejne jako u AI, resi zda moho pouzit schopnost dle fazovace,
            * ale jinak podminky stejne
            * musi se pridat chyb hlaska pro schopnosti jako je Viktor, Valeria jejichz schopnost bezi porad
            */
            if ((aktivni == "modrak") & (OdhSchop.Text == "Použij schopnost"))
            {

                string[] cile = { "cervenka", "zelenka", "modrak", "zlutka" };
                string[] misto = { cervenka.misto, zelenka.misto, modrak.misto, zlutka.misto };
                int[] schopnosti = { cervenka.schop, zelenka.schop, modrak.schop, zlutka.schop };

                cil = "";
                x = 0;
                y = 0;
                mistoHP = 0;

                // reseni cile
                if (hr1.Checked)
                    cil = "cervenka";
                if (hr2.Checked)
                    cil = "zelenka";
                if (hr4.Checked)
                    cil = "zlutka";

                //hrac nemuze napadnout sam sebe
                /*if (hr3.Checked)
                    error = new Error();
                */


                if ((fazovac.Text == "Začátek hry") | (fazovac.Text == "Pohyb"))
                {
                    #region Ultima
                    if ((modrak.jmeno == "Ultima") & (modrak.schop == 0) & (modrak.stav != "vyrazen"))
                    {
                        if ((cil == "") & (modrak.jmeno == "Ultima"))
                        {
                            MessageBox.Show("Nebyl zvolen cil schopnosti.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            return;
                        }

                        if (hr3.Checked)
                        {
                            Error error = new Error();
                            MessageBox.Show(error.chybka, "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            hr3.Checked = false;
                            return;
                        }

                        while (cil != cile[y])
                        {
                            y++;
                        }
                        if (misto[y] == "hrbitov")
                            mistoHP = 2;
                        else
                        {
                            MessageBox.Show("Vybraný cíl se nenachází na hřbitově. Vyber jiný.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            return;
                        }

                    }
                    #endregion
                    #region Fenrir + Gabrin
                    if (((modrak.jmeno == "Fenrir") | (modrak.jmeno == "Gabrin")) & (modrak.schop == 0) & (modrak.stav != "vyrazen"))
                    {

                        switch (modrak.jmeno)
                        {
                            case "Fenrir":
                                x = Convert.ToInt32(sestka.Text);
                                ctyrka.Text = "0";
                                break;
                            case "Gabrin":
                                x = Convert.ToInt32(ctyrka.Text);
                                sestka.Text = "0";
                                break;
                        }

                        if ((sestka.Text == "0") & (ctyrka.Text == "0"))
                        {
                            MessageBox.Show("Nebylo hozeno kostkou pro urceni zranění cíle.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            return;
                        }


                        if ((cil != "") & (modrak.stav == "odhalen") & (modrak.schop == 0))
                        {
                            mistoHP = x;
                            modrak.schop = 1;
                            MessageBox.Show("Cil " + cil + " byl zraněn za: " + x + " životů.", "Výsledek", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        }
                    }
                    #endregion

                    #region Freya
                    if ((modrak.jmeno == "Freya") & (modrak.schop == 0) & (modrak.stav != "vyrazen"))
                    {

                        if ((cil != "") & (modrak.stav == "odhalen"))
                        {
                            switch (cil)
                            {
                                case "cervenka":
                                    cervenka.zraneni = 7;
                                    break;
                                case "zelenka":
                                    zelenka.zraneni = 7;
                                    break;
                                case "modrak":
                                    modrak.zraneni = 7;
                                    break;
                                case "zlutka":
                                    zlutka.zraneni = 7;
                                    break;
                            }
                            mistoHP = 0;
                            modrak.schop = 1;
                        }

                        
                    }
                    #endregion

                    #region Elektra
                    if ((modrak.jmeno == "Elektra") & (modrak.schop == 0) & (modrak.stav != "vyrazen"))
                    {
                        y = 0;

                        while (cil != cile[y])
                        {
                            y++;
                        }

                        if (schopnosti[y] == 1)
                        {
                            MessageBox.Show("Zvolený cíl má již vyčerpanou schopnost. Vyber někoho jiného.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            return;
                        }
                        if (schopnosti[y] == 0)
                        {
                            schopnosti[y] = 1;
                            modrak.schop = 1;
                        }

                        cervenka.schop = schopnosti[0];
                        zelenka.schop = schopnosti[1];
                        //modrak.schop = schopnosti[2];
                        zlutka.schop = schopnosti[3];

                    }
                    #endregion
                    switch (cil)
                    {
                        case "cervenka":
                            cervenka.zraneni = cervenka.zraneni + mistoHP;
                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            red_hp.Location = new Point(zacatek.hp_rx, zraneni.y);
                            break;
                        case "zelenka":
                            zelenka.zraneni = zelenka.zraneni + mistoHP;
                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            green_hp.Location = new Point(zacatek.hp_gx, zraneni.y);
                            break;
                        case "modrak":
                            modrak.zraneni = modrak.zraneni + mistoHP;
                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            blue_hp.Location = new Point(zacatek.hp_bx, zraneni.y);
                            break;
                        case "zlutka":
                            zlutka.zraneni = zlutka.zraneni + mistoHP;
                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            yellow_hp.Location = new Point(zacatek.hp_yx, zraneni.y);
                            break;
                    }
                    return;
                }

                if (fazovac.Text == "Boj")
                {
                    if ((modrak.jmeno == "Viktor") | (modrak.jmeno == "Valeria") & (modrak.schop == 0))
                    {
                        MessageBox.Show("Tvá schopnost je aktivní stále. Nemusíš mačkat toto tlačítko.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        return;
                    }


                }

            }

            if ((fazovac.Text == "Boj") & (cil == "modrak") & (OdhSchop.Text == "Použij schopnost") & (modrak.stav != "vyrazen"))
            {
                #region Wren
                if ((modrak.jmeno == "Wren") & (modrak.schop == 0))
                {
                    cil = aktivni;
                    aktivni = "modrak";

                    //overeni hodu kostkami
                    Error error = new Error(sestka.Text, ctyrka.Text);
                    if (error.chybka != "")
                    {
                        MessageBox.Show(error.chybka, "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }

                    //reseni andela pro hrace
                    error = new Error(aktivni, cil, karta.modra[0, 3]);
                    if (error.chybka != "")
                    {
                        MessageBox.Show(error.chybka, "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Error);

                        return;
                    }

                    if (aktivni == karta.cervena[14, 3])
                    {
                        sestka.Text = "0";
                        masakr = new Boj(aktivni, ctyrka.Text, sestka.Text, cervenka.utocneC, zelenka.utocneC, modrak.utocneC,
                        zlutka.utocneC);
                    }
                    else
                    {
                        //cil nepotrebuji - Misto nej pak prijde moznost vybrat si pravidla pro boj na zacatku hry
                        masakr = new Boj(aktivni, sestka.Text, ctyrka.Text, cervenka.utocneC, zelenka.utocneC, modrak.utocneC,
                        zlutka.utocneC);
                    }

                    switch (cil)
                    {
                        case "cervenka":
                            if (karta.modra[14, 3] == "cervenka")
                            {
                                zranA = masakr.z - 1;
                                if (zranA < 0)
                                    zranA = 0;

                                cervenka.zraneni = cervenka.zraneni + zranA;
                            }
                            else
                                cervenka.zraneni = cervenka.zraneni + masakr.z;

                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            red_hp.Location = new Point(zacatek.hp_rx, zraneni.y);
                            break;
                        case "zelenka":
                            if (karta.modra[14, 3] == "zelenka")
                            {
                                zranA = masakr.z - 1;
                                if (zranA < 0)
                                    zranA = 0;

                                zelenka.zraneni = zelenka.zraneni + zranA;
                            }
                            else
                                zelenka.zraneni = zelenka.zraneni + masakr.z;
                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            green_hp.Location = new Point(zacatek.hp_gx, zraneni.y);
                            break;
                        case "modrak":
                            if (karta.modra[14, 3] == "modrak")
                            {
                                zranA = masakr.z - 1;
                                if (zranA < 0)
                                    zranA = 0;

                                modrak.zraneni = modrak.zraneni + zranA;
                            }
                            else
                                modrak.zraneni = modrak.zraneni + masakr.z;
                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            blue_hp.Location = new Point(zacatek.hp_bx, zraneni.y);
                            break;
                        case "zlutka":
                            if (karta.modra[14, 3] == "zlutka")
                            {
                                zranA = masakr.z - 1;
                                if (zranA < 0)
                                    zranA = 0;

                                zlutka.zraneni = zlutka.zraneni + zranA;
                            }
                            else
                                zlutka.zraneni = zlutka.zraneni + masakr.z;
                            zraneni = new Zraneni(cil, cervenka.zraneni, zelenka.zraneni, modrak.zraneni, zlutka.zraneni);
                            yellow_hp.Location = new Point(zacatek.hp_yx, zraneni.y);
                            break;
                    }

                    aktivni = cil;
                    return;
                }
                #endregion
            }

            if ((OdhSchop.Text == "Použij schopnost") & (modrak.schop == 1))
            {
                MessageBox.Show("Buď jsi svou schopnost již použil, nebo ti byla zakázána.", "Chyba", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

        }
    }
    
}
